#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <strings.h>
extern int inthp();
#define EPSILON 0.0000001
#define TRUE 1
#define FALSE 0
#define GAMMARATES 10
#define PATTERNS 15

//#define log(a) (a==0.0 ? -1e100 : log(a))

typedef struct helper_fmt
{
    double *result;
    double **resulta;
    double theta;
    double ttratio;
    double t0;
    double *xxx1;
    double *xxx2;
    long *patsum;
    long *pattern;
    long nx;
    long sites;
    double basefreq[4];
    double weight;
    short final;
    double time1;
    double alpha;
    double* gamma;
    double freq;
    
}
helper_fmt;

void calc_gamma (double alpha, double *gamma);
double incompletegamma (double x, double alpha);
double phi (double t, void *b);
double phimaster(double t, void *b);
double evaluate_rates(helper_fmt *helper);


void read_data(char *file,char **s1, char **s2,
               long *loci,long *sites,double *xs,
               double *xe,double *xstep, double *ys,
               double *ye, double *ystep)
{
  FILE *fp;

  long i,dummy1=0,ss=0, ll=0;
  char *dummy3,*dummy4;
  fp = fopen(file,"r");
  dummy3 = (char *) calloc(1,sizeof(char)*1100);
  dummy4 = (char *) calloc(1,sizeof(char)*11);
  *xe = 0; *xs=-5; *ys=-5; *ye=0; 
  *xstep=.1; *ystep=0.05;
  fscanf(fp,"%ld%ld\n%ld",&dummy1,&ll,&ss);
  if(ll==0 && ss==0)
    {
      fprintf(stderr,"Data files has wrong syntax\nneeds to be:\n\n 1 loci\nsites_per_locus\n2 \nname1     sequence\nname2     sequence\n...next locus...\n\n\n");
    }
  *loci = ll;
  *sites = ss;
  fgets(dummy3,1024,fp);  fgets(dummy3,1024,fp);
  for(i=0;i< *loci;i++)
    fscanf(fp,"%10s%10000s\n%10s%10000s\n",dummy3,s1[i],dummy4,s2[i]);
  fclose(fp);
}


void 
nuview(double ttratio, double t1, double t2, long *pattern, double *xxx1, long nx1, double *xxx2, long nx2, 
		double *basefreq, long basen, double *result)
{
  short i;
  long z=0;
  double lw1, lw2, yy1, yy2, ww1zz1, vv1zz1, ww2zz2, vv2zz2, vzsumr1, vzsumr2,
    vzsumy1, vzsumy2, sum1, sum2, sumr1, sumr2, sumy1, sumy2, ww1, ww2,
    zz1, zz2;
  double freqa = basefreq[0];
  double freqc = basefreq[1];
  double freqg = basefreq[2];
  double freqt = basefreq[3];
  double freqar,freqgr, freqr, freqy, freqcy, freqty;
  double aa,bb, xi,xv,fracchange;
  
  double xx1[4],  xx2[4];
  freqr = freqa + freqg;
  freqy = freqc + freqt;
  freqar = freqa/ freqr;
  freqcy = freqc/ freqy;
  freqgr = freqg / freqr;
  freqty = freqt / freqy;
  aa = ttratio * (freqr) * (freqy)
    - freqa * freqg - freqc * freqt;
  bb = freqa * (freqgr) + freqc * (freqty);
  xi = aa / (aa + bb);
  xv = 1.0 - xi;
  fracchange=(xi) * (2 * freqa * (freqgr)
				 + 2 * freqc * (freqty)) +
    (xv) * (1.0 - freqa * freqa
		 - freqc * freqc - freqg
		 * freqg
		 - freqt * freqt);
  lw1 = -t1 / fracchange;
  ww1 = exp (xi * lw1);
  zz1 = exp (xv * lw1);
  ww1zz1 = ww1 * zz1;
  vv1zz1 = (1.0 - ww1) * zz1;
  lw2 = -t2 / fracchange;
  ww2 = exp (xi * lw2);
  zz2 = exp (xv * lw2);
  ww2zz2 = ww2 * zz2;
  vv2zz2 = (1.0 - ww2) * zz2;
  yy1 = 1.0 - zz1;
  yy2 = 1.0 - zz2;
  for (i = 0; i < 15; i++)
    {
      switch(i)
	{
	case 0: xx1[0]=1;xx1[1]=0;xx1[2]=0;xx1[3]=0;
	        xx2[0]=1;xx2[1]=0;xx2[2]=0;xx2[3]=0;break;
	case 1: xx1[0]=1;xx1[1]=0;xx1[2]=0;xx1[3]=0;
	        xx2[0]=0;xx2[1]=1;xx2[2]=0;xx2[3]=0;break;
	case 2: xx1[0]=1;xx1[1]=0;xx1[2]=0;xx1[3]=0;
	        xx2[0]=0;xx2[1]=0;xx2[2]=1;xx2[3]=0;break;
	case 3: xx1[0]=1;xx1[1]=0;xx1[2]=0;xx1[3]=0;
	        xx2[0]=0;xx2[1]=0;xx2[2]=0;xx2[3]=1;break;
	case 4: xx1[0]=0;xx1[1]=1;xx1[2]=0;xx1[3]=0;
	        xx2[0]=0;xx2[1]=1;xx2[2]=0;xx2[3]=0;break;
	case 5: xx1[0]=0;xx1[1]=1;xx1[2]=0;xx1[3]=0;
	        xx2[0]=0;xx2[1]=0;xx2[2]=1;xx2[3]=0;break;
	case 6: xx1[0]=0;xx1[1]=1;xx1[2]=0;xx1[3]=0;
	        xx2[0]=0;xx2[1]=0;xx2[2]=0;xx2[3]=1;break;
	case 7: xx1[0]=0;xx1[1]=0;xx1[2]=1;xx1[3]=0;
	        xx2[0]=0;xx2[1]=0;xx2[2]=1;xx2[3]=0;break;
	case 8: xx1[0]=0;xx1[1]=0;xx1[2]=1;xx1[3]=0;
	        xx2[0]=0;xx2[1]=0;xx2[2]=0;xx2[3]=1;break;
	case 9: xx1[0]=0;xx1[1]=0;xx1[2]=0;xx1[3]=1;
	        xx2[0]=0;xx2[1]=0;xx2[2]=0;xx2[3]=1;break;
	case 10: xx1[0]=1;xx1[1]=1;xx1[2]=1;xx1[3]=1;
	         xx2[0]=1;xx2[1]=1;xx2[2]=1;xx2[3]=1;break;
	case 11: xx1[0]=1;xx1[1]=1;xx1[2]=1;xx1[3]=1;
	         xx2[0]=1;xx2[1]=0;xx2[2]=0;xx2[3]=0;break;
	case 12: xx1[0]=1;xx1[1]=1;xx1[2]=1;xx1[3]=1;
	         xx2[0]=0;xx2[1]=1;xx2[2]=0;xx2[3]=0;break;
	case 13: xx1[0]=1;xx1[1]=1;xx1[2]=1;xx1[3]=1;
	         xx2[0]=0;xx2[1]=0;xx2[2]=1;xx2[3]=0;break;
	case 14: xx1[0]=1;xx1[1]=1;xx1[2]=1;xx1[3]=1;
	         xx2[0]=0;xx2[1]=0;xx2[2]=0;xx2[3]=1;break;
	}
      sum1 = yy1 * (freqa * xx1[0] + freqc * xx1[1] +
		    freqg * xx1[2] + freqt
		    * xx1[3]);
      sum2 = yy2 * (freqa * xx2[0] + freqc * xx2[1] +
		    freqg * xx2[2] + freqt
		    * xx2[3]);
      sumr1 = freqar * xx1[0] + freqgr * xx1[2];
      sumr2 = freqar * xx2[0] + freqgr * xx2[2];
      sumy1 = freqcy * xx1[1]
	+ freqty * xx1[3];
      sumy2 = freqcy * xx2[1]
	+  freqty * xx2[3];
      vzsumr1 = vv1zz1 * sumr1;
      vzsumr2 = vv2zz2 * sumr2;
      vzsumy1 = vv1zz1 * sumy1;
      vzsumy2 = vv2zz2 * sumy2;
      result[z] = (sum1 + ww1zz1 * xx1[0] + vzsumr1) *
	(sum2 + ww2zz2 * xx2[0] + vzsumr2) * freqa;
      result[z] +=
	(sum1 + ww1zz1 * xx1[1] + vzsumy1) *
	(sum2 + ww2zz2 * xx2[1] + vzsumy2) * freqc;
      result[z] +=
	(sum1 + ww1zz1 * xx1[2] + vzsumr1) *
	(sum2 + ww2zz2 * xx2[2] + vzsumr2) * freqg;
      result[z] +=
	(sum1 + ww1zz1 * xx1[3] + vzsumy1) *
	(sum2 + ww2zz2 * xx2[3] + vzsumy2) * freqt;
      z++;
    }
}


void conditional(char *seq1, char *seq2, long *patsum, long *pattern, long sites)
{
  long i,x;
  for(i=0;i<sites;i++)
    {
      switch(toupper(seq1[i]))
	{
	case 'A': x=1; break;
	case 'C': x=10; break;
	case 'G': x=100; break;
	case 'T': x=1000; break;
	case '-':
	case '?':
	default: x=1111; break;
	}
      switch(toupper(seq2[i]))
	{
	case 'A': x +=1; break;
	case 'C': x +=10; break;
	case 'G': x +=100; break;
	case 'T': x +=1000; break;
	case '-':
	case '?':
	default: x +=1111; break;
	}
      switch(x)
	{
      /*AA=2[0] AC=11[1] AG=101[2] AT=1001[3] 
	CC=20[4] CG=110[5] CT=1010[6] GG=200[7] GT=1100[8] TT=2000[9]*/
	case 2: patsum[0]++; pattern[i]=0;break;
	case 11: patsum[1]++; pattern[i]=1; break;
	case 101: patsum[2]++; pattern[i]=2; break;
	case 1001: patsum[3]++; pattern[i]=3; break;
	case 20:  patsum[4]++; pattern[i]=4;break;
	case 110:  patsum[5]++; pattern[i]=5;break;
	case 1010: patsum[6]++;  pattern[i]=6;break;
	case 200: patsum[7]++;  pattern[i]=7;break;
	case 1100: patsum[8]++;  pattern[i]=8;break;
	case 2000: patsum[9]++;  pattern[i]=9;break;
	case 2222: patsum[10]++;  pattern[i]=10;break;
	case 1112: patsum[11]++;  pattern[i]=11;break;
	case 1121: patsum[12]++;  pattern[i]=12;break;
	case 1211: patsum[13]++;  pattern[i]=13;break;
	case 2111: patsum[14]++;  pattern[i]=14;break;
	default: exit(-1);
	}
    }
}

int setbasefreq(long numsites, char *s1, char *s2, double *basefreq)
{
    long site;
    double sum=0;
    
    basefreq[0] = basefreq[1] = basefreq[2] = basefreq[3] = 0.;
    for(site=0;site<numsites;site++)
    {
        basefreq[0] +=
            (s1[site] == 'A' ? 1 : 0)
            +(s2[site] == 'A' ? 1 : 0);
        basefreq[1] +=
            (s1[site] == 'C' ? 1 : 0)
            +(s2[site] == 'C' ? 1 : 0);
        basefreq[2] +=
            (s1[site] == 'G' ? 1 : 0)
            +(s2[site] == 'G' ? 1 : 0);
        basefreq[3] +=
            (s1[site] == 'T' ? 1 : 0)
            +(s2[site] == 'T' ? 1 : 0);
        
    }
    sum = (basefreq[0]+
                    basefreq[1]+
                    basefreq[2]+
           basefreq[3]);
    
    basefreq[0] /= sum;
    basefreq[1] /= sum;
    basefreq[2] /= sum;
    basefreq[3] /= sum;
    if(basefreq[0]<=EPSILON || basefreq[1]<=EPSILON ||
       basefreq[2]<=EPSILON || basefreq[3]<=EPSILON )
        return 1;
    else
        return 0;
}


int main(int argc, char *argv[])
{
char notbayes=FALSE;
    
  long i,check=0, loci=1;
  int err = 0;
  
  double maxweight=0;
  helper_fmt *helper;
  double bottom,top;
  long m, inf, failinf, which,guardmax=1, sites=0, guard=0;
  double result=0.0;
  double xb,xe,xstep,yb,ye,ystep;
  double a,b,d,p,eps;
  char **seq1, **seq2;
  helper = (helper_fmt *) calloc(1, sizeof(helper_fmt)*1);
  seq1= (char **) calloc(1,sizeof(char*)*100);
  seq2= (char **) calloc(1,sizeof(char*)*100);
#ifdef RECTPRIOR
  fprintf(stderr,"[Using Rectangular prior for ancestral population size]\n");
#else
#ifdef EXPPRIOR
  fprintf(stderr,"[Using exp(-theta/c)/c prior for ancestral population size, c arbitrary, don't use this]\n");
#else
  fprintf(stderr,"[Using 1/theta prior for ancestral population size (~Jeffreys' prior?)]\n");
#endif
#endif
  if(argc>1 && strstr(argv[1],"--help"))
    {
      fprintf(stderr,"diverge filename <+|maxweight>\n");
      fprintf(stderr,"             maxweighttrials whichlocus\n");
      fprintf(stderr,"             priorlowerbound priorupperbound\n");
      fprintf(stderr,"             log10-start log10-stop interval>\n");
      fprintf(stderr,"             ttratio time_first_sequence alpha >\n");
      fprintf(stderr,"Default:\n");
      fprintf(stderr," diverge filename + 1 0 0 10 -5 0 0.05 2.0 0 Infinity\n");
      exit(-1);
    } 
  if(argc==1)
    {
      fprintf(stderr,"diverge filename <+|maxweight>\n");
      fprintf(stderr,"             maxweighttrials whichlocus\n");
      fprintf(stderr,"             priorlowerbound priorupperbound>\n");
      fprintf(stderr,"             log10-start log10-stop interval>\n");
      fprintf(stderr,"             ttratio time_first_sequence alpha >\n");
      fprintf(stderr,"Default:\n");
      fprintf(stderr," diverge filename + 1 0 0 10 -5 0 0.05 2.0 0 Infinity\n");
      exit(-1);
    } 
    for(i=0;i<100;i++)
      {
	seq1[i] = (char *) calloc(1,2000*sizeof(char));
	seq2[i] = (char *) calloc(1,2000*sizeof(char));
      }
  read_data(argv[1],seq1,seq2, &loci, &sites, &xb, &xe, &xstep, &yb, &ye, &ystep);
  
  //  fprintf(stderr,"Range for theta and tau\nIn log_10 [%f-%f(%f), %f-%f(%f)]\n",
  //	  xb,xe,xstep,yb,ye,ystep);
  //  fgets(input,1024,stdin);
  //  if ((input[0]!='\0')&&(input[0]!='\n'))
  //    {
  //     sscanf(input,"%lf%lf%lf%lf%lf%lf",&xb,&xe,&xstep,&yb,&ye,&ystep);
  //    } 
  helper->patsum = (long *) calloc(1,sizeof(long)*14);
  helper->pattern = (long *) calloc(1,sizeof(long)*sites*4);
  helper->xxx1 = (double *) calloc(1,sizeof(double)*sites*4);
  helper->xxx2 = (double *) calloc(1,sizeof(double)*sites*4);
  helper->result = (double *) calloc(1,sizeof(double) * sites * 4);
  helper->resulta = (double **) calloc(1,sizeof(double*) * sites * 4);
  helper->resulta[0] = (double *) calloc(1,sizeof(double) *
                                         sites * 4 * GAMMARATES);
  for(i=1;i<sites * 4;i++)
      helper->resulta[i] = helper->resulta[0] + i * GAMMARATES;
  helper->sites =sites;
  if(argc>=5)
    which = atoi(argv[4]);
  else 
    which=0;
  fprintf(stderr,"Used sequences:\n%s\n\n%s\n\n",seq1[which],seq2[which]);
for(i=which;i<loci;i++)
    {
      maxweight=0;
      conditional(seq1[i],seq2[i],helper->patsum,helper->pattern,sites);
      helper->nx = 15;
          /*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
            You need to adjust the base frequencies!!!!!!!!!!!!!!!
          */
      err= setbasefreq(helper->sites,seq1[i],seq2[i],helper->basefreq);
      if(err!=0)
      {
	helper->basefreq[0] = 0.25; //human 0.321; //A
          helper->basefreq[1] = 0.25; //human 0.314; //C
          helper->basefreq[2] = 0.25; //human 0.132; //G
          helper->basefreq[3] = 0.25; //human 0.233; //T
          fprintf(stderr, "automatic basefrequency assignment failed\n");
          fprintf(stderr, "using:{acgt=%f %f %f %f}\n",
                 helper->basefreq[0],helper->basefreq[1],
                 helper->basefreq[2],helper->basefreq[3]);
      }
      else
      {
          fprintf(stderr,"automatic basefrequency assignment\n");
          fprintf(stderr,"using:{acgt=%f %f %f %f}\n",
                 helper->basefreq[0],helper->basefreq[1],
                 helper->basefreq[2],helper->basefreq[3]);
      }
      
      helper->weight=0.;
      helper->final=0;
      if(argc>2){
	if(argv[2][0]=='+')
	  check=0;
	else 
	  check=1;
      }
      else
	check=0;
      
      if(check)
	{
	  if(argc>=4)
	    guardmax=atof(argv[3]);
	  maxweight=atof(argv[2]);            
	}
      else
      {
          maxweight= 0;
          
	  if(argc>=4)
	    guardmax=atof(argv[3]);
	}
      if(argc>=10)
      {
	  yb = atof(argv[7]);
	  ye = atof(argv[8]);
	  ystep = atof(argv[9]);
      }
      
      helper->ttratio=2.0;
      helper->time1=0.;
      helper->alpha=10000;
      
      if(argc>=11)
      {
          helper->ttratio=atof(argv[10]);          
      }
      if(argc>=12)
      {
          helper->time1=atof(argv[11]);
          helper->time1 /= 2.;
      }
      if(argc>=13)
      {
          helper->alpha=atof(argv[12]);
          helper->gamma = (double *) calloc(1,sizeof(double)*GAMMARATES);
          calc_gamma(helper->alpha,helper->gamma);
      }
      helper->final=1;
      #define MAX(a,b) ((a) < (b) ? (b) : (a))
      fprintf(stderr,"guardmax=%li\nmaxweight=%f\n",guardmax,maxweight);
      for(helper->t0=MAX(pow(10.,yb)-helper->time1,helper->time1);
          helper->t0<pow(10.,ye+ystep)-helper->time1;
	  helper->t0 = helper->t0 * pow(10.,ystep))
      {
          if(argc==14)
          {
              bottom=atof(argv[13]);
          }
          else
              bottom= -500000;
	  top =  0;
          if(maxweight==0)
              helper->weight=bottom;
          else
          {
              helper->weight=maxweight;
              top=maxweight;
              bottom=maxweight;
          }
//          if(maxweight==0)
              guard=0;
	  result=-10;
	  goto xx;
	  while(guard++ < guardmax)
	    {
	      if(result>1e-4 && result<1e10)
		break;
	      else
		{
		  if(isnan(result)!=0)
		    {
		      bottom=helper->weight;
		      goto xx ;
		    }
		  if(result==0 && inf==4)
		    {
		      top=helper->weight;
		      goto xx;
		    }
		  if(result > 1e10)
		    {
		      bottom=helper->weight;
		      goto xx;
		    }
		  if(result < 1e-1)
		    {
		      top=helper->weight;
		      goto xx;
		    }
		}
	    xx:
	      helper->weight = bottom + (top - bottom)/2.;
	      if(argc>4)
		{
		  a=atof(argv[5]);
		  b=atof(argv[6]);
                  helper->freq=1.;
                  if(b==0.0)
                  {    
                      notbayes=TRUE;
                      helper->freq=1.;
                  }
                  else
                  {
                      notbayes=FALSE;    
                  }
		}
	      else
		{
		  a = 0.0;
		  b = 10.;
		}
	      d = 1.0;
	      p = 1.;
	      eps = 10e-15;
	      m = 100;
	      failinf=inf;
#ifdef RECTPRIOR
	       inf = 4;
#else
	       inf = 2;
#endif
	      result =0.;
              if(!notbayes)
                  inthp (&a, &b, &d, phimaster, &m, &p, 
                         &eps, &inf, (void *) (helper), &result);
	      else
              {
                  helper->theta=a;
                  a=0;
                  b=1000.;
                  
                  inthp (&a, &b, &d, phi, &m, &p, 
                         &eps, &inf, (void *) (helper), &result);
              }
	  fprintf(stderr,"**%li:%2li %g %g %g %20.20g %li\n ",
		  which, guard, 
		  helper->t0+helper->time1,result,log(result)+helper->weight, helper->weight,inf);
	    }
fprintf(stdout,"%20.20g %20.20g\n ",
		  helper->t0+helper->time1,log(result)+helper->weight);
	  
	   
	}
      if(argc>=5)
	break;
    }
return 0;
}
  

double 
phimaster(double t, void *b)
{
  double a;	 
  double bb;
  double d = 1.0;
  double p = 1.;
  double eps = 10e-15;
  long m = 100;
  long inf = 4;
  double result=0;
  helper_fmt *helper;
  helper = (helper_fmt *) b;
  bb = 1000;
    helper->theta = t;
  a=helper->time1;
  inthp (&a, &bb, &d, phi, &m, &p, &eps, &inf, (void *) (helper), &result);
//  fprintf(stderr,"%4li %g \n",zz++, result);
#ifdef RECTPRIOR
  return result;// * helper->freq;
#else
#ifdef EXPPRIOR
  //  fprintf(stderr,"e");
  return exp(-helper->theta/0.0035) * (1./0.0035) * result;
#else
  return 1./helper->theta * result;
#endif

#endif
}

 
double
phi (double t, void *b)
{    
    long i,ii;
    double r,result=0.;  
    helper_fmt *helper;
    helper = (helper_fmt *) b;
    if(helper->alpha>=10000)
    {      
        nuview(helper->ttratio, t+helper->t0, t+helper->t0,
               helper->pattern, helper->xxx1, helper->sites, 
               helper->xxx2, helper->sites, helper->basefreq,
               4,helper->result);
        for(i=0;i<helper->nx;i++)
        {
            if(helper->patsum[i]!=0)
                result += log(helper->result[i])*helper->patsum[i];
        }

    }
    else
    {
        for(ii=0;ii<GAMMARATES;ii++)//over discrete gamma rates
        {
            memset(helper->resulta[ii],0,sizeof(double)*helper->nx);
            r = helper->gamma[ii];
            nuview(helper->ttratio,r*(t +helper->t0),r*(t+ helper->t0),
                   helper->pattern, helper->xxx1, helper->sites, 
                   helper->xxx2, helper->sites, helper->basefreq,
                   4,helper->resulta[ii]);
        }
        result = evaluate_rates(helper);
    }
    if(helper->theta!=0.0)
        result += -t * 2. / helper->theta  + log(2./helper->theta);
    if(helper->final)
    {
        result -= helper->weight;
        return exp(result);
    }
    return result;
}



/* calculation of rate values following a gamma distribution for
   given probability values */
void
calc_gamma (double alpha, double *gamma)
{
  long i, panic;
  double low, mid, high, xlow, xhigh, tmp, freq = 0, x = 10,
    elements = (double) 10;
  freq = -(0.5 / elements);	/*so we have midpoints instead of endpoints */
  for (i = 0; i < elements; i++)
    {
      low = 0;
      mid = incompletegamma (10., alpha);
      high = 1.;
      freq += 1. / (elements);
      if (freq < mid)
	{
	  high = mid;
	  xlow = 0;
	  xhigh = 10.;
	  x = 5.;
	}
      else
	{
	  low = mid;
	  xhigh = 1e10;
	  xlow = 10.;
	  x = 1e5;
	}
      panic = 0;
      while (panic++ < 1000 && fabs (low - high) > 0.0001 && x > 0.000000001)
	{
	  mid = incompletegamma (x, alpha);
	  if (freq < mid)
	    {
	      high = mid;
	      tmp = x;
	      x = (x + xlow) / 2.;
	      xhigh = tmp;
	    }
	  else
	    {
	      low = mid;
	      tmp = x;
	      x = (x + xhigh) / 2.;
	      xlow = tmp;
	    }
	}
      gamma[i] = x / alpha;
      fprintf(stderr,"%li> %f\n",i,gamma[i]);
      
      if (x >= 10e10)
	{
            exit(-999);
	}
    }
  
}

/* Algorithm AS66 Applied Statistics (1973) vol22 no.3
   Evaluates the tail area of the standardised normal curve
   from x to infinity if upper is .true. or
   from minus infinity to x if upper is .false. */
double 
alnorm (double x, int up)
{
  /* Initialized data */
  /* *** machine dependent constants ????????????? */
  static double zero = 0.;
  static double a1 = 5.75885480458;
  static double a2 = 2.62433121679;
  static double a3 = 5.92885724438;
  static double b1 = -29.8213557807;
  static double b2 = 48.6959930692;
  static double c1 = -3.8052e-8;
  static double c2 = 3.98064794e-4;
  static double c3 = -.151679116635;
  static double c4 = 4.8385912808;
  static double c5 = .742380924027;
  static double one = 1.;
  static double c6 = 3.99019417011;
  static double d1 = 1.00000615302;
  static double d2 = 1.98615381364;
  static double d3 = 5.29330324926;
  static double d4 = -15.1508972451;
  static double d5 = 30.789933034;
  static double half = .5;
  static double ltone = 7.;
  static double utzero = 18.66;
  static double con = 1.28;
  static double p = .398942280444;
  static double q = .39990348504;
  static double r = .398942280385;

  static double y, result;

  if (x < zero)
    {
      up = !up;
      x = -x;
    }
  if (x <= ltone || (up && x <= utzero))
    {
      y = half * x * x;
      if (x > con)
	{
	  result = r * exp (-y) / (x + c1 + d1 / (x + c2 + d2 / (x + c3 + d3 / (x +
				     c4 + d4 / (x + c5 + d5 / (x + c6))))));
	  return ((!up) ? one - result : result);
	}
      result = half - x * (p - q * y / (y + a1 + b1 / (y + a2 + b2 / (y + a3))));
      return ((!up) ? one - result : result);
    }
  else
    {
      return ((!up) ? 1.0 : 0.);
    }
  /*fake */ return -99;
}				/* alnorm */

/* ALGORITHM AS239  APPL. STATIST. (1988) VOL. 37, NO. 3 
   Computation of the Incomplete Gamma Integral 
   Auxiliary functions required: lgamma() = logarithm of the gamma 
   function, and alnorm() = algorithm AS66 */
double 
incompletegamma (double x, double alpha)
{
  double gama, d_1, d_2, d_3;
  static double a, b, c, an, rn;
  static double pn1, pn2, pn3, pn4, pn5, pn6, arg;

  gama = 0.;
  /*  Check that we have valid values for X and P */
  if (alpha <= 0. || x < 0.)
    {
      exit (-2);
    }
  if (x == 0.)
    {
      return gama;
    }

  /*  Use a normal approximation if P > PLIMIT */
  if (alpha > 1e3)
    {
      pn1 = sqrt (alpha) * 3. * (pow (x / alpha, (1. / 3.)) + 1. / (alpha * 9.) - 1.);
      gama = alnorm (pn1, 0);
      return gama;
    }

  /*  If X is extremely large compared to P then set GAMMAD = 1 */
  if (x > 1e8)
    {
      gama = 1.;
      return gama;
    }

  if (x <= 1. || x < alpha)
    {
      /*  Use Pearson's series expansion. */
      /*  (Note that P is not large enough to force overflow in lgamma()). */
      arg = alpha * log (x) - x - lgamma (alpha + 1.);
      c = 1.;
      gama = 1.;
      a = alpha;
      while (c > 1e-14)
	{
	  a += 1.;
	  c = c * x / a;
	  gama += c;
	}
      arg += log (gama);
      gama = 0.;
      if (arg >= -88.)
	{
	  gama = exp (arg);
	}

    }
  else
    {
      /*  Use a continued fraction expansion */
      arg = alpha * log (x) - x - lgamma (alpha);
      a = 1. - alpha;
      b = a + x + 1.;
      c = 0.;
      pn1 = 1.;
      pn2 = x;
      pn3 = x + 1.;
      pn4 = x * b;
      gama = pn3 / pn4;
      for (;;)
	{
	  a += 1.;
	  b += 2.;
	  c += 1.;
	  an = a * c;
	  pn5 = b * pn3 - an * pn1;
	  pn6 = b * pn4 - an * pn2;
	  if (fabs (pn6) > 0.)
	    {
	      rn = pn5 / pn6;
	      /* Computing MIN */
	      d_2 = 1e-14, d_3 = rn * 1e-14;
	      if ((d_1 = gama - rn, fabs (d_1)) <= (d_2<d_3?d_2:d_3))
		{
		  arg += log (gama);
		  gama = 1.;
		  if (arg >= -88.)
		    {
		      gama = 1. - exp (arg);
		    }
		  return gama;
		}
	      gama = rn;
	    }
	  pn1 = pn3;
	  pn2 = pn4;
	  pn3 = pn5;
	  pn4 = pn6;
	  if (fabs (pn5) >= 1e37)
	    {
	      /*  Re-scale terms in continued fraction if terms are large */
	      pn1 /= 1e37;
	      pn2 /= 1e37;
	      pn3 /= 1e37;
	      pn4 /= 1e37;
	    }
	}
    }
  /*fake */
  return gama;
}				/* incompletegamma() */

/* evaluates the likelihood of the data using GAMMARATES coming
   from a discrete gamma distribution */
double evaluate_rates(helper_fmt *helper)
{
    long site,gam,pat;
    double sum=0,lterm,sumc=0,sumterm=0;
    static double contribution[GAMMARATES][PATTERNS];
    static double nulike[PATTERNS];
    const double probcat = 1./ GAMMARATES; //each rate has the same prob
        // because we are using calc_gamma to construct rates
        // with equal probabilities.
    for(pat=0;pat<PATTERNS;pat++)
    {
        if(helper->patsum[pat]!=0)
        {
            sumterm = 0;
            for(gam=0;gam<GAMMARATES;gam++)
            {
                sumterm += probcat * helper->resulta[gam][pat];
            }                                            
            lterm = log(sumterm);
            for(gam=0;gam<GAMMARATES;gam++)
                contribution[gam][pat] = helper->resulta[gam][pat]/sumterm;
            sum += helper->patsum[pat] * lterm;
        }
        else
        {
            for(gam=0;gam<GAMMARATES;gam++)
                contribution[gam][pat] = 0;
        }
    }
    for(gam=0;gam<GAMMARATES;gam++)
        nulike[gam]=1.;
    for(site=0;site<helper->sites;site++)
    {
        sumc=0;
        for(gam=0;gam<GAMMARATES;gam++)
            sumc +=  probcat * nulike[gam];
        nulike[0]= sumc;
        for(gam=1;gam<GAMMARATES;gam++)
            nulike[gam] = sumc *  contribution[gam][helper->pattern[site]-1];
    }
    sumc=0;
    for(gam=0;gam<GAMMARATES;gam++)
        sumc += probcat * nulike[gam];
    return sum + log(sumc);
}







