(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 4.2'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    104104,       3032]*)
(*NotebookOutlinePosition[    104768,       3055]*)
(*  CellTagsIndexPosition[    104724,       3051]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
    \(SetDirectory["\</Users/beerli/src/bayes-diverge\>"]\)], "Input"],

Cell[BoxData[
    \("/Users/beerli/src/bayes-diverge"\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(d1\  = \ 
        ReadList["\<result.testdata.0.00001-0.05-0.11-0\>", {Number, 
            Number}];\)\)], "Input"],

Cell[BoxData[
    \(\(dj\  = \ 
        ReadList["\<result.testdata.0.00001-0.05-0.11-0-jeffreys\>", {Number, 
            Number}];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Max[d1]\)], "Input"],

Cell[BoxData[
    \(11.220184543019527722999999999989778`19.301\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(g1 = 
      ListPlot[Map[{#[\([1]\)], #[\([2]\)] - 
                Max[\(Transpose[d1]\)[\([2]\)]]} &, d1], 
        PlotJoined \[Rule] \ True]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Scaling calculations
0.0238095 0.380978 0.603319 0.0306886 [
[.2143 .59082 -10.2812 -14 ]
[.2143 .59082 10.2812 0 ]
[.40479 .59082 -5.3125 -14 ]
[.40479 .59082 5.3125 0 ]
[.59528 .59082 -10.2812 -14 ]
[.59528 .59082 10.2812 0 ]
[.78577 .59082 -5.3125 -14 ]
[.78577 .59082 5.3125 0 ]
[.97625 .59082 -10.2812 -14 ]
[.97625 .59082 10.2812 0 ]
[.01131 .14299 -25.5 -7 ]
[.01131 .14299 0 7 ]
[.01131 .29643 -25.5 -7 ]
[.01131 .29643 0 7 ]
[.01131 .44988 -18.875 -7 ]
[.01131 .44988 0 7 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2143 .60332 m
.2143 .60957 L
s
gsave
.2143 .59082 -71.2812 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.40479 .60332 m
.40479 .60957 L
s
gsave
.40479 .59082 -66.3125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.59528 .60332 m
.59528 .60957 L
s
gsave
.59528 .59082 -71.2812 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.5) show
1.000 setlinewidth
grestore
.78577 .60332 m
.78577 .60957 L
s
gsave
.78577 .59082 -66.3125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.97625 .60332 m
.97625 .60957 L
s
gsave
.97625 .59082 -71.2812 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.125 Mabswid
.06191 .60332 m
.06191 .60707 L
s
.10001 .60332 m
.10001 .60707 L
s
.1381 .60332 m
.1381 .60707 L
s
.1762 .60332 m
.1762 .60707 L
s
.2524 .60332 m
.2524 .60707 L
s
.29049 .60332 m
.29049 .60707 L
s
.32859 .60332 m
.32859 .60707 L
s
.36669 .60332 m
.36669 .60707 L
s
.44289 .60332 m
.44289 .60707 L
s
.48098 .60332 m
.48098 .60707 L
s
.51908 .60332 m
.51908 .60707 L
s
.55718 .60332 m
.55718 .60707 L
s
.63337 .60332 m
.63337 .60707 L
s
.67147 .60332 m
.67147 .60707 L
s
.70957 .60332 m
.70957 .60707 L
s
.74767 .60332 m
.74767 .60707 L
s
.82386 .60332 m
.82386 .60707 L
s
.86196 .60332 m
.86196 .60707 L
s
.90006 .60332 m
.90006 .60707 L
s
.93816 .60332 m
.93816 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .14299 m
.03006 .14299 L
s
gsave
.01131 .14299 -86.5 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(15) show
1.000 setlinewidth
grestore
.02381 .29643 m
.03006 .29643 L
s
gsave
.01131 .29643 -86.5 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.02381 .44988 m
.03006 .44988 L
s
gsave
.01131 .44988 -79.875 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.125 Mabswid
.02381 .17368 m
.02756 .17368 L
s
.02381 .20437 m
.02756 .20437 L
s
.02381 .23506 m
.02756 .23506 L
s
.02381 .26574 m
.02756 .26574 L
s
.02381 .32712 m
.02756 .32712 L
s
.02381 .35781 m
.02756 .35781 L
s
.02381 .3885 m
.02756 .3885 L
s
.02381 .41919 m
.02756 .41919 L
s
.02381 .48056 m
.02756 .48056 L
s
.02381 .51125 m
.02756 .51125 L
s
.02381 .54194 m
.02756 .54194 L
s
.02381 .57263 m
.02756 .57263 L
s
.02381 .1123 m
.02756 .1123 L
s
.02381 .08161 m
.02756 .08161 L
s
.02381 .05092 m
.02756 .05092 L
s
.02381 .02024 m
.02756 .02024 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.02381 .41643 m
.02381 .41643 L
.02381 .41643 L
.02381 .41643 L
.02382 .41643 L
.02382 .41643 L
.02382 .41643 L
.02382 .41644 L
.02382 .41644 L
.02382 .41644 L
.02382 .41644 L
.02382 .41644 L
.02382 .41645 L
.02383 .41645 L
.02383 .41646 L
.02383 .41646 L
.02383 .41647 L
.02384 .41647 L
.02384 .41648 L
.02384 .41648 L
.02385 .41649 L
.02385 .4165 L
.02386 .41651 L
.02386 .41652 L
.02387 .41653 L
.02388 .41655 L
.02389 .41656 L
.02389 .41658 L
.02391 .4166 L
.02392 .41662 L
.02393 .41665 L
.02394 .41668 L
.02396 .41671 L
.02398 .41674 L
.024 .41678 L
.02402 .41683 L
.02405 .41688 L
.02408 .41693 L
.02411 .417 L
.02415 .41707 L
.02419 .41715 L
.02424 .41723 L
.02429 .41733 L
.02435 .41745 L
.02441 .41757 L
.02449 .41771 L
.02457 .41787 L
.02466 .41805 L
.02477 .41825 L
.02488 .41847 L
Mistroke
.02501 .41872 L
.02516 .419 L
.02533 .41932 L
.02551 .41967 L
.02572 .42007 L
.02595 .42051 L
.02621 .42101 L
.02651 .42157 L
.02684 .42221 L
.0272 .42291 L
.02762 .42371 L
.02808 .4246 L
.02861 .4256 L
.02919 .42673 L
.02985 .42799 L
.03058 .42942 L
.03141 .43101 L
.03234 .43281 L
.03338 .43483 L
.03455 .4371 L
.03586 .43965 L
.03733 .44252 L
.03898 .44576 L
.04083 .44941 L
.0429 .45352 L
.04523 .45816 L
.04785 .46341 L
.05078 .46935 L
.05407 .47609 L
.05776 .48377 L
.06191 .49255 L
.06656 .50268 L
.07177 .51444 L
.07762 .52811 L
.08419 .54353 L
.09156 .5598 L
.09982 .57538 L
.1091 .58862 L
.11951 .59822 L
.13118 .6033 L
.14429 .60332 L
.15899 .59795 L
.17548 .587 L
.19399 .5703 L
.21475 .54773 L
.23805 .51916 L
.26419 .48445 L
.29352 .44343 L
.32643 .39594 L
.36336 .34178 L
Mistroke
.40479 .28078 L
.45127 .21278 L
.50343 .13766 L
.56196 .05534 L
Mfstroke
.56196 .05534 m
.60255 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`007?ooool00`00003oooooooooo`2Dooooo`030000
0?oooooooooo06[ooooo000Looooo`0300000?oooooooooo09Cooooo00<00000ooooooooool0J_oo
ool001cooooo00<00000ooooooooool0Toooool00`00003oooooooooo`1[ooooo`007?ooool00`00
003oooooooooo`2Booooo`0300000?oooooooooo06cooooo000Looooo`0300000?oooooooooo097o
oooo00<00000ooooooooool0KOooool001cooooo00<00000o`000?ooool0T?ooool00`00003ooooo
ooooo`1^ooooo`007?ooool00`00003oooooooooo`2@ooooo`0300000?oooooooooo06kooooo000L
ooooo`0300000?oooooooooo08oooooo00<00000ooooooooool0Koooool001cooooo00<00000oooo
ooooool0S_ooool00`00003oooooooooo`1`ooooo`007?ooool00`00003oooooooooo`2=ooooo`03
00000?oooooooooo077ooooo000Looooo`0300000?oooooooooo08gooooo00<00000ooooooooool0
LOooool001cooooo00<00000ooooooooool0S?ooool00`00003oooooooooo`1booooo`007?ooool0
0`00003oooooooooo`2;ooooo`0300000?oooooooooo07?ooooo000Looooo`0300000?l0003ooooo
08[ooooo00<00000ooooooooool0M?ooool001cooooo00<00000ooooooooool0ROooool00`00003o
ooooooooo`1eooooo`007?ooool00`00003oooooooooo`29ooooo`0300000?oooooooooo07Gooooo
000Looooo`0300000?oooooooooo08Sooooo00<00000ooooooooool0M_ooool001cooooo00<00000
ooooooooool0Qoooool00`00003oooooooooo`1gooooo`007?ooool00`00003oooooooooo`26oooo
o`0300000?oooooooooo07Sooooo000Looooo`0300000?oooooooooo08Kooooo00<00000oooooooo
ool0N?ooool001cooooo00<00000ooooooooool0QOooool00`00003oooooooooo`1iooooo`007?oo
ool00`00003o0000ooooo`24ooooo`0300000?oooooooooo07[ooooo000Looooo`0300000?oooooo
oooo08Cooooo00<00000ooooooooool0N_ooool001cooooo00<00000ooooooooool0Poooool00`00
003oooooooooo`1kooooo`007?ooool00`00003oooooooooo`22ooooo`0300000?oooooooooo07co
oooo000Looooo`0300000?oooooooooo087ooooo00<00000ooooooooool0OOooool001cooooo00<0
0000ooooooooool0POooool00`00003oooooooooo`1mooooo`007?ooool00`00003oooooooooo`20
ooooo`0300000?oooooooooo07kooooo000Looooo`0300000?oooooooooo07oooooo00<00000oooo
ooooool0Ooooool001cooooo00<00000o`000?ooool0Ooooool00`00003oooooooooo`1oooooo`00
7?ooool00`00003oooooooooo`1nooooo`0300000?oooooooooo083ooooo000Looooo`0300000?oo
oooooooo07gooooo00<00000ooooooooool0POooool001cooooo00<00000ooooooooool0O?ooool0
0`00003oooooooooo`22ooooo`007?ooool00`00003oooooooooo`1looooo`0300000?oooooooooo
08;ooooo000Looooo`0300000?oooooooooo07_ooooo00<00000ooooooooool0Poooool000gooooo
00?o0000ooooooooool00_ooool4o`0000Kooooo00<00000ooooooooool0N_ooool00`00003ooooo
ooooo`24ooooo`003Oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool0
0oooool00`00003oooooooooo`1jooooo`0300000?oooooooooo08Cooooo000=ooooo`03o`000?oo
oooooooo00Kooooo00?o0000ooooooooool00oooool3000007Wooooo00<00000ooooooooool0QOoo
ool000?ooooo1ol00003ooooo`03o`000?oooooooooo00Kooooo00?o0000ooooooooool00oooool0
0`00003oooooooooo`1hooooo`0300000?oooooooooo08Kooooo000=ooooo`05o`000?oooooooooo
ooooool000001?ooool00ol0003oooooooooo`03ooooo`0300000?oooooooooo07Sooooo00<00000
ooooooooool0Q_ooool000gooooo00Co0000oooooooooooooooo1Ol00006ooooo`0300000?oooooo
oooo07Oooooo00<00000ooooooooool0Qoooool000_ooooo0ol00003ooooo`03o`000?oooooooooo
00Sooooo00<00000ooooooooool0M_ooool00`00003oooooooooo`28ooooo`003Oooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00Oooooo00<00000ooooooooool0M_ooool00`00003o
ooooooooo`28ooooo`003Oooool00ol0003oooooooooo`02ooooo`Go00001Oooool00`00003ooooo
ooooo`1eooooo`0300000?oooooooooo08Wooooo000Looooo`0300000?oooooooooo07Cooooo00<0
0000ooooooooool0R_ooool001cooooo00<00000o`000?ooool0M?ooool00`00003oooooooooo`2:
ooooo`007?ooool00`00003oooooooooo`1cooooo`0300000?oooooooooo08_ooooo000Looooo`03
00000?oooooooooo07?ooooo00<00000ooooooooool0Roooool001cooooo00<00000ooooooooool0
L_ooool00`00003oooooooooo`2<ooooo`007?ooool00`00003oooooooooo`1aooooo`0300000?oo
oooooooo08gooooo000Looooo`0300000?oooooooooo077ooooo00<00000ooooooooool0SOooool0
01cooooo00<00000ooooooooool0L?ooool00`00003oooooooooo`2>ooooo`007?ooool00`00003o
ooooooooo`1_ooooo`0300000?oooooooooo08oooooo000Looooo`0300000?l0003ooooo06oooooo
00<00000ooooooooool0Soooool001cooooo00<00000ooooooooool0K_ooool00`00003ooooooooo
o`2@ooooo`007?ooool00`00003oooooooooo`1]ooooo`0300000?oooooooooo097ooooo000Loooo
o`0300000?oooooooooo06gooooo00<00000ooooooooool0TOooool001cooooo00<00000oooooooo
ool0K?ooool00`00003oooooooooo`2Booooo`007?ooool00`00003oooooooooo`1[ooooo`030000
0?oooooooooo09?ooooo000Looooo`0300000?oooooooooo06[ooooo00<00000ooooooooool0U?oo
ool001cooooo00<00000ooooooooool0J_ooool00`00003oooooooooo`2Dooooo`007?ooool00`00
003o0000ooooo`1Yooooo`0300000?oooooooooo09Gooooo000Looooo`0300000?oooooooooo06So
oooo00<00000ooooooooool0U_ooool001cooooo00<00000ooooooooool0J?ooool00`00003ooooo
ooooo`2Fooooo`007?ooool00`00003oooooooooo`1Wooooo`0300000?oooooooooo09Oooooo000L
ooooo`0300000?oooooooooo06Kooooo00<00000ooooooooool0V?ooool001cooooo00<00000oooo
ooooool0IOooool00`00003oooooooooo`2Iooooo`007?ooool00`00003oooooooooo`1Uooooo`03
00000?oooooooooo09Wooooo000Looooo`0300000?oooooooooo06Cooooo00<00000ooooooooool0
V_ooool001cooooo00<00000o`000?ooool0Hoooool00`00003oooooooooo`2Kooooo`007?ooool0
0`00003oooooooooo`1Sooooo`0300000?oooooooooo09_ooooo000Looooo`0300000?oooooooooo
06;ooooo00<00000ooooooooool0W?ooool001cooooo00<00000ooooooooool0HOooool00`00003o
ooooooooo`2Mooooo`007?ooool00`00003oooooooooo`1Pooooo`0300000?oooooooooo09kooooo
000Looooo`0300000?oooooooooo063ooooo00<00000ooooooooool0W_ooool000gooooo00?o0000
ooooooooool00_ooool4o`0000Kooooo00<00000ooooooooool0Goooool00`00003oooooooooo`2O
ooooo`003Oooool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00oooool0
0`00003oooooooooo`1Nooooo`0300000?oooooooooo0:3ooooo000=ooooo`05o`000?oooooooooo
ooooool000001?ooool00ol0003oooooooooo`03ooooo`<00000G_ooool00`00003oooooooooo`2P
ooooo`000oooool7o`0000?ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooo
oooo00?ooooo00<00000ooooooooool0GOooool00`00003oooooooooo`2Qooooo`003Oooool01Ol0
003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00oooool00`00003oooooooooo`1M
ooooo`0300000?oooooooooo0:7ooooo000=ooooo`05o`000?ooooooooooooooool000001?ooool0
0ol0003oooooooooo`03ooooo`0300000?oooooooooo05cooooo00<00000ooooooooool0X_ooool0
00_ooooo0ol00003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00`00
003oooooooooo`1Kooooo`0300000?oooooooooo0:?ooooo000=ooooo`05o`000?oooooooooooooo
ool000001?ooool00ol0003oooooooooo`03ooooo`0300000?oooooooooo05_ooooo00<00000oooo
ooooool0Xoooool000gooooo00?o0000ooooooooool00_ooool4o`0000Kooooo00<00000oooooooo
ool0F_ooool00`00003oooooooooo`2Tooooo`007?ooool00`00003oooooooooo`1Iooooo`030000
0?oooooooooo0:Gooooo000Looooo`0300000?l0003ooooo05Wooooo00<00000ooooooooool0YOoo
ool001cooooo00<00000ooooooooool0F?ooool00`00003oooooooooo`2Vooooo`007?ooool00`00
003oooooooooo`1Hooooo`0300000?oooooooooo0:Kooooo000Looooo`0300000?oooooooooo05Oo
oooo00<00000ooooooooool0Yoooool001cooooo00<00000ooooooooool0E_ooool00`00003ooooo
ooooo`2Xooooo`007?ooool00`00003oooooooooo`1Fooooo`03o`000?oooooooooo0:Sooooo000L
ooooo`0300000?oooooooooo05Gooooo00?o0000ooooooooool0ZOooool001cooooo00<00000oooo
ooooool0E?ooool00ol0003oooooooooo`2Zooooo`007?ooool00`00003o0000ooooo`1Cooooo`03
o`000?oooooooooo0:_ooooo000Looooo`0300000?oooooooooo05?ooooo00?o0000ooooooooool0
Zoooool001cooooo00<00000ooooooooool0D_ooool00ol0003oooooooooo`2/ooooo`007?ooool0
0`00003oooooooooo`1Aooooo`03o`000?oooooooooo0:gooooo000Looooo`0300000?oooooooooo
057ooooo00?o0000ooooooooool0[Oooool001cooooo00<00000ooooooooool0D?ooool00ol0003o
ooooooooo`2^ooooo`007?ooool00`00003oooooooooo`1?ooooo`03o`000?oooooooooo0:oooooo
000Looooo`0300000?oooooooooo04kooooo00?o0000ooooooooool0/?ooool001cooooo00<00000
o`000?ooool0C_ooool00ol0003oooooooooo`2`ooooo`007?ooool00`00003oooooooooo`1=oooo
o`03o`000?oooooooooo0;7ooooo000Looooo`0300000?oooooooooo04cooooo00?o0000oooooooo
ool0/_ooool001cooooo00<00000ooooooooool0C?ooool00ol0003oooooooooo`2booooo`007?oo
ool00`00003oooooooooo`1;ooooo`03o`000?oooooooooo0;?ooooo000Looooo`0300000?oooooo
oooo04[ooooo00?o0000ooooooooool0]?ooool001cooooo00<00000ooooooooool0BOooool00ol0
003oooooooooo`2eooooo`007?ooool2o`0004[ooooo00?o0000ooooooooool0]Oooool001cooooo
00<00000o`000?ooool0B?ooool00ol0003oooooooooo`2fooooo`007?ooool00`00003o0000o`00
0017ooooo`03o`000?oooooooooo0;Oooooo000Looooo`0300000?oooooo000004Kooooo00?o0000
ooooooooool0^?ooool001cooooo00<00000ooooool00000A_ooool00ol0003oooooooooo`2hoooo
o`007?ooool01000003oooooooooool00014ooooo`03o`000?oooooooooo0;Wooooo000Looooo`04
00000?ooooooooooo`0004?ooooo00?o0000ooooooooool0^_ooool0017ooooo1?l00007ooooo`05
00000?ooooooooooooooool00000@Oooool00ol0003oooooooooo`2kooooo`004?ooool00ol0003o
ooooooooo`02ooooo`03o`000?oooooooooo00Cooooo00D00000ooooooooooooooooo`000011oooo
o`03o`000?oooooooooo0;_ooooo000Eooooo`03o`000?oooooooooo00Cooooo0`000002ooooo`03
o`000?oooooooooo03gooooo00?o0000ooooooooool0_?ooool000Wooooo1ol00005ooooo`03o`00
0?oooooooooo00Cooooo00<00000ooooooooool00_ooool00ol0003oooooooooo`0looooo`03o`00
0?oooooooooo0;gooooo000@ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01?oo
ool00`00003oooooooooo`03ooooo`03o`000?oooooooooo03_ooooo00?o0000ooooooooool0_Ooo
ool0013ooooo1Ol00007ooooo`0300000?oooooooooo00Cooooo00?o0000ooooooooool0>Oooool0
0ol0003oooooooooo`2nooooo`004?ooool00ol0003oooooooooo`09ooooo`0300000?oooooooooo
00Cooooo00?o0000ooooooooool0>?ooool00ol0003oooooooooo`2oooooo`004Oooool00ol0003o
ooooooooo`08ooooo`0300000?oooooooooo00Cooooo00?o0000ooooooooool0>?ooool00ol0003o
ooooooooo`2oooooo`004Oooool5o`0000Kooooo00<00000ooooooooool01?ooool00ol0003ooooo
ooooo`0gooooo`03o`000?oooooooooo0<3ooooo000Looooo`0300000?oooooooooo00Gooooo00?o
0000ooooooooool0=_ooool00ol0003oooooooooo`30ooooo`007?ooool00`00003o0000ooooo`05
ooooo`03o`000?oooooooooo03Gooooo00?o0000ooooooooool0`Oooool001cooooo00<00000oooo
ooooool01_ooool00ol0003oooooooooo`0cooooo`03o`000?oooooooooo0<;ooooo000Looooo`03
00000?oooooooooo00Kooooo00?o0000ooooooooool0<oooool00ol0003oooooooooo`32ooooo`00
7?ooool00`00003oooooooooo`07ooooo`03o`000?oooooooooo037ooooo00?o0000ooooooooool0
`oooool001cooooo00<00000ooooooooool01oooool00ol0003oooooooooo`0`ooooo`03o`000?oo
oooooooo0<Cooooo000Looooo`0300000?oooooooooo00Sooooo00?o0000ooooooooool0;_ooool0
0ol0003oooooooooo`35ooooo`007?ooool00`00003oooooooooo`08ooooo`03o`000?oooooooooo
02gooooo00?o0000ooooooooool0a_ooool001cooooo00<00000ooooooooool02Oooool00ol0003o
ooooooooo`0/ooooo`03o`000?oooooooooo0<Kooooo000Looooo`0300000?l0003ooooo00Wooooo
00?o0000ooooooooool0:oooool00ol0003oooooooooo`37ooooo`007?ooool00`00003ooooooooo
o`0:ooooo`03o`000?oooooooooo02Wooooo00?o0000ooooooooool0b?ooool001cooooo00<00000
ooooooooool02_ooool00ol0003oooooooooo`0Xooooo`03o`000?oooooooooo0<Wooooo000Loooo
o`0300000?oooooooooo00_ooooo00?o0000ooooooooool09oooool00ol0003oooooooooo`39oooo
o`007?ooool00`00003oooooooooo`0;ooooo`03o`000?oooooooooo02Kooooo00?o0000oooooooo
ool0b_ooool001cooooo00<00000ooooooooool02oooool00ol0003oooooooooo`0Uooooo`03o`00
0?oooooooooo0<_ooooo000Looooo`0300000?oooooooooo00cooooo00?o0000ooooooooool08ooo
ool00ol0003oooooooooo`3<ooooo`007?ooool00`00003oooooooooo`0<ooooo`03o`000?oooooo
oooo02;ooooo00?o0000ooooooooool0cOooool001cooooo00<00000o`000?ooool03Oooool00ol0
003oooooooooo`0Pooooo`03o`000?oooooooooo0<kooooo000Looooo`0300000?oooooooooo00go
oooo00?o0000ooooooooool07oooool00ol0003oooooooooo`3?ooooo`007?ooool00`00003ooooo
ooooo`0>ooooo`03o`000?oooooooooo01kooooo00?o0000ooooooooool0coooool001cooooo00<0
0000ooooooooool03_ooool00ol0003oooooooooo`0Gooooo`Co00000_ooool2o`0000;ooooo1?l0
000Zooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`04o`0002Oooooo1_l0000Wooooo`Ko00000_ooool00ol0003oooooooooo`04o`0000Gooooo000L
ooooo`0300000?oooooooooo00oooooo00?o0000ooooooooool05Oooool00ol0003oooooooooo`02
ooooo`;o00000oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo02Oooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool09?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`02ooooo`007?ooool00`00003oooooooooo`0?oooo
o`03o`000?oooooooooo01Gooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`07oooo
o`03o`000?oooooooooo02Oooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`09oooo
o`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`0;oooo
o`03o`000?oooooooooo00;ooooo000Looooo`0300000?oooooooooo013ooooo00?o0000oooooooo
ool05?ooool01?l0003oooooooooooooool2o`0000Wooooo00?o0000ooooooooool09oooool00ol0
003oooooooooo`0Zooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool09_ooool2o`00
02_ooooo0_l0000;ooooo`03o`000?oooooooooo00;ooooo000Looooo`0300000?oooooooooo013o
oooo00?o0000ooooooooool05?ooool01_l0003oooooo`000?l0003oooooo`0000Cooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`0Wooooo`03o`000?oooooooooo02[ooooo00?o0000
ooooooooool01?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo02Sooooo00?o0000
ooooooooool0:_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool00_ooool001cooooo00<00000o`000?ooool04Oooool00ol0003oooooooooo`0Coooo
o`;o00000oooool00ol0003oooooooooo`02ooooo`Go0000:_ooool00ol0003oooooooooo`0Zoooo
o`03o`000?oooooooooo00Cooooo1Ol0000/ooooo`03o`000?oooooooooo02[ooooo00?o0000oooo
ooooool00_ooool5o`0000Gooooo000Looooo`0300000?oooooooooo017ooooo00?o0000oooooooo
ool04oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool0:_ooool3o`0002[ooooo0ol00006ooooo`03o`000?oooooooooo02Wooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`07ooooo`007?ooool00`00003oooooooooo`0Booooo`03o`00
0?oooooooooo017ooooo0_l00004ooooo`03o`000?oooooooooo00?ooooo00?o0000ooooooooool0
:oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Gooooo00?o0000ooooooooool0
:?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo02Gooooo00?o0000ooooooooool0
0_ooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00Kooooo000Looooo`0300000?oo
oooooooo01;ooooo00?o0000ooooooooool03oooool2o`0000;ooooo1?l00006ooooo`Go0000:Ooo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Gooooo1Ol0000Wooooo`Co0000:Ooo
ool4o`0000Kooooo1Ol00004ooooo`007?ooool00`00003oooooooooo`0Cooooo`;o00003Oooool2
o`000=gooooo000Looooo`0300000?oooooooooo01Gooooo00?o0000ooooooooool02Oooool00ol0
003oooooooooo`3Mooooo`007?ooool00`00003oooooooooo`0Fooooo`;o00001oooool2o`000>3o
oooo000Looooo`0300000?oooooooooo01Sooooo00?o0000ooooooooool00oooool00ol0003ooooo
ooooo`3Pooooo`005_oooolR000000Go0000gP000005ooooo`007?ooool00`00003oooooooooo`07
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`06
ooooo`03o`000?oooooooooo00Oooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07
ooooo`03o`000?oooooooooo00Wooooo000Looooo`0300000?oooooooooo0?oooooo0_ooool001co
oooo00<00000ooooooooool0ooooool2ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.289916, -20.663, \
0.0100821, 0.125163}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(g2 = 
      ListPlot[Map[{#[\([1]\)], #[\([2]\)] - 
                Max[\(Transpose[dj]\)[\([2]\)]]} &, dj], 
        PlotStyle \[Rule] RGBColor[1, 0, 0], 
        PlotJoined \[Rule] True]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Scaling calculations
0.0238095 0.380978 0.603319 0.0251831 [
[.2143 .59082 -10.2812 -14 ]
[.2143 .59082 10.2812 0 ]
[.40479 .59082 -5.3125 -14 ]
[.40479 .59082 5.3125 0 ]
[.59528 .59082 -10.2812 -14 ]
[.59528 .59082 10.2812 0 ]
[.78577 .59082 -5.3125 -14 ]
[.78577 .59082 5.3125 0 ]
[.97625 .59082 -10.2812 -14 ]
[.97625 .59082 10.2812 0 ]
[.01131 .09966 -25.5 -7 ]
[.01131 .09966 0 7 ]
[.01131 .22557 -25.5 -7 ]
[.01131 .22557 0 7 ]
[.01131 .35149 -25.5 -7 ]
[.01131 .35149 0 7 ]
[.01131 .4774 -18.875 -7 ]
[.01131 .4774 0 7 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2143 .60332 m
.2143 .60957 L
s
gsave
.2143 .59082 -71.2812 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.40479 .60332 m
.40479 .60957 L
s
gsave
.40479 .59082 -66.3125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.59528 .60332 m
.59528 .60957 L
s
gsave
.59528 .59082 -71.2812 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.5) show
1.000 setlinewidth
grestore
.78577 .60332 m
.78577 .60957 L
s
gsave
.78577 .59082 -66.3125 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.97625 .60332 m
.97625 .60957 L
s
gsave
.97625 .59082 -71.2812 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
.125 Mabswid
.06191 .60332 m
.06191 .60707 L
s
.10001 .60332 m
.10001 .60707 L
s
.1381 .60332 m
.1381 .60707 L
s
.1762 .60332 m
.1762 .60707 L
s
.2524 .60332 m
.2524 .60707 L
s
.29049 .60332 m
.29049 .60707 L
s
.32859 .60332 m
.32859 .60707 L
s
.36669 .60332 m
.36669 .60707 L
s
.44289 .60332 m
.44289 .60707 L
s
.48098 .60332 m
.48098 .60707 L
s
.51908 .60332 m
.51908 .60707 L
s
.55718 .60332 m
.55718 .60707 L
s
.63337 .60332 m
.63337 .60707 L
s
.67147 .60332 m
.67147 .60707 L
s
.70957 .60332 m
.70957 .60707 L
s
.74767 .60332 m
.74767 .60707 L
s
.82386 .60332 m
.82386 .60707 L
s
.86196 .60332 m
.86196 .60707 L
s
.90006 .60332 m
.90006 .60707 L
s
.93816 .60332 m
.93816 .60707 L
s
.25 Mabswid
0 .60332 m
1 .60332 L
s
.02381 .09966 m
.03006 .09966 L
s
gsave
.01131 .09966 -86.5 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(20) show
1.000 setlinewidth
grestore
.02381 .22557 m
.03006 .22557 L
s
gsave
.01131 .22557 -86.5 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(15) show
1.000 setlinewidth
grestore
.02381 .35149 m
.03006 .35149 L
s
gsave
.01131 .35149 -86.5 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
1.000 setlinewidth
grestore
.02381 .4774 m
.03006 .4774 L
s
gsave
.01131 .4774 -79.875 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.125 Mabswid
.02381 .12484 m
.02756 .12484 L
s
.02381 .15002 m
.02756 .15002 L
s
.02381 .17521 m
.02756 .17521 L
s
.02381 .20039 m
.02756 .20039 L
s
.02381 .25076 m
.02756 .25076 L
s
.02381 .27594 m
.02756 .27594 L
s
.02381 .30112 m
.02756 .30112 L
s
.02381 .3263 m
.02756 .3263 L
s
.02381 .37667 m
.02756 .37667 L
s
.02381 .40185 m
.02756 .40185 L
s
.02381 .42704 m
.02756 .42704 L
s
.02381 .45222 m
.02756 .45222 L
s
.02381 .50259 m
.02756 .50259 L
s
.02381 .52777 m
.02756 .52777 L
s
.02381 .55295 m
.02756 .55295 L
s
.02381 .57814 m
.02756 .57814 L
s
.02381 .07447 m
.02756 .07447 L
s
.02381 .04929 m
.02756 .04929 L
s
.02381 .02411 m
.02756 .02411 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
1 0 0 r
.5 Mabswid
.02381 .55105 m
.02381 .55105 L
.02381 .55105 L
.02381 .55105 L
.02382 .55105 L
.02382 .55105 L
.02382 .55105 L
.02382 .55105 L
.02382 .55105 L
.02382 .55105 L
.02382 .55105 L
.02382 .55105 L
.02382 .55105 L
.02383 .55105 L
.02383 .55105 L
.02383 .55105 L
.02383 .55105 L
.02384 .55105 L
.02384 .55105 L
.02384 .55105 L
.02385 .55105 L
.02385 .55105 L
.02386 .55106 L
.02386 .55106 L
.02387 .55106 L
.02388 .55106 L
.02389 .55106 L
.02389 .55106 L
.02391 .55107 L
.02392 .55107 L
.02393 .55107 L
.02394 .55107 L
.02396 .55108 L
.02398 .55108 L
.024 .55109 L
.02402 .55109 L
.02405 .5511 L
.02408 .5511 L
.02411 .55111 L
.02415 .55112 L
.02419 .55113 L
.02424 .55114 L
.02429 .55115 L
.02435 .55116 L
.02441 .55117 L
.02449 .55119 L
.02457 .55121 L
.02466 .55123 L
.02477 .55125 L
.02488 .55128 L
Mistroke
.02501 .5513 L
.02516 .55134 L
.02533 .55137 L
.02551 .55141 L
.02572 .55146 L
.02595 .55151 L
.02621 .55156 L
.02651 .55163 L
.02684 .5517 L
.0272 .55178 L
.02762 .55187 L
.02808 .55197 L
.02861 .55209 L
.02919 .55222 L
.02985 .55237 L
.03058 .55254 L
.03141 .55272 L
.03234 .55294 L
.03338 .55318 L
.03455 .55346 L
.03586 .55377 L
.03733 .55413 L
.03898 .55453 L
.04083 .555 L
.0429 .55554 L
.04523 .55616 L
.04785 .55687 L
.05078 .55771 L
.05407 .55869 L
.05776 .55985 L
.06191 .56125 L
.06656 .56297 L
.07177 .56517 L
.07762 .56815 L
.08419 .5724 L
.09156 .57837 L
.09982 .58582 L
.1091 .59352 L
.11951 .59982 L
.13118 .60332 L
.14429 .60312 L
.15899 .5987 L
.17548 .58978 L
.19399 .57616 L
.21475 .55773 L
.23805 .53436 L
.26419 .50593 L
.29352 .47232 L
.32643 .43337 L
.36336 .38894 L
Mistroke
.40479 .33889 L
.45127 .28308 L
.50343 .22142 L
.56196 .15386 L
.62762 .08039 L
.70129 .00108 L
Mfstroke
.70129 .00108 m
.70234 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`007?ooool00`00003oooooooooo`2^ooooo`03ool0
0?oooooooooo053ooooo000Looooo`0300000?oooooooooo0:kooooo00<0o`00ooooooooool0D?oo
ool001cooooo00<00000ooooooooool0[Oooool00`3o003oooooooooo`1Aooooo`007?ooool00`00
003oooooooooo`2/ooooo`030?l00?oooooooooo05;ooooo000Looooo`0300000?oooooooooo0:_o
oooo00<0o`00ooooooooool0Doooool001cooooo00<00000ooooooooool0Z_ooool00`3o003ooooo
ooooo`1Dooooo`007?ooool00`00003o0000ooooo`2Yooooo`030?l00?oooooooooo05Gooooo000L
ooooo`0300000?oooooooooo0:Sooooo00<0o`00ooooooooool0E_ooool001cooooo00<00000oooo
ooooool0Yoooool00`3o003oooooooooo`1Gooooo`007?ooool00`00003oooooooooo`2Vooooo`03
0?l00?oooooooooo05Sooooo000Looooo`0300000?oooooooooo0:Gooooo00<0o`00ooooooooool0
FOooool001cooooo00<00000ooooooooool0Y?ooool00`3o003oooooooooo`1Jooooo`007?ooool0
0`00003o0000ooooo`2Sooooo`030?l00?oooooooooo05_ooooo000Looooo`0300000?oooooooooo
0:;ooooo00<0o`00ooooooooool0G?ooool001cooooo00<00000ooooooooool0XOooool00`3o003o
ooooooooo`1Mooooo`007?ooool00`00003oooooooooo`2Pooooo`030?l00?oooooooooo05kooooo
000Looooo`0300000?oooooooooo09oooooo00<0o`00ooooooooool0Goooool001cooooo00<00000
ooooooooool0W_ooool00`3o003oooooooooo`1Pooooo`007?ooool00`00003oooooooooo`2Moooo
o`030?l00?oooooooooo067ooooo000Looooo`0300000?l0003ooooo09cooooo00<0o`00oooooooo
ool0H_ooool001cooooo00<00000ooooooooool0Voooool00`3o003oooooooooo`1Sooooo`007?oo
ool00`00003oooooooooo`2Jooooo`030?l00?oooooooooo06Cooooo000Looooo`0300000?oooooo
oooo09[ooooo00<0o`00ooooooooool0I?ooool001cooooo00<00000ooooooooool0VOooool00`3o
003oooooooooo`1Uooooo`002_ooool6o`0000;ooooo1?l00006ooooo`0300000?oooooooooo09So
oooo00<0o`00ooooooooool0I_ooool000[ooooo00?o0000ooooooooool01?ooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00?ooooo00<00000ooooooooool0Uoooool00`3o003ooooo
ooooo`1Wooooo`002oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool00oooool3000009Kooooo00<0o`00ooooooooool0J?ooool000?ooooo1ol00002
ooooo`;o00000oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00<00000
ooooooooool0UOooool00`3o003oooooooooo`1Yooooo`003_ooool01?l0003oooooooooool00004
ooooo`03o`000?oooooooooo00?ooooo00<00000ooooooooool0U?ooool00`3o003oooooooooo`1Z
ooooo`003oooool00ol0003oooooo`000004ooooo`03o`000?oooooooooo00?ooooo00<00000oooo
ooooool0Toooool00`3o003oooooooooo`1[ooooo`002_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooo000000Cooooo00?o0000ooooooooool00oooool00`00003oooooooooo`2Booooo`03
0?l00?oooooooooo06cooooo000:ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooool00000
1?ooool00ol0003oooooooooo`03ooooo`0300000?oooooooooo097ooooo00<0o`00ooooooooool0
KOooool000_ooooo1?l00003ooooo`Co00001_ooool00`00003o0000ooooo`2Aooooo`030?l00?oo
oooooooo06gooooo000Looooo`0300000?oooooooooo093ooooo00<0o`00ooooooooool0K_ooool0
01cooooo00<00000ooooooooool0Soooool00`3o003oooooooooo`1_ooooo`007?ooool00`00003o
ooooooooo`2>ooooo`030?l00?oooooooooo073ooooo000Looooo`0300000?oooooooooo08gooooo
00<0o`00ooooooooool0LOooool001cooooo00<00000ooooooooool0S?ooool00`3o003ooooooooo
o`1booooo`007?ooool00`00003oooooooooo`2;ooooo`030?l00?oooooooooo07?ooooo000Loooo
o`0300000?l0003ooooo08[ooooo00<0o`00ooooooooool0M?ooool001cooooo00<00000oooooooo
ool0ROooool00`3o003oooooooooo`1eooooo`007?ooool00`00003oooooooooo`29ooooo`030?l0
0?oooooooooo07Gooooo000Looooo`0300000?oooooooooo08Sooooo00<0o`00ooooooooool0M_oo
ool001cooooo00<00000ooooooooool0Qoooool00`3o003oooooooooo`1gooooo`007?ooool00`00
003oooooooooo`26ooooo`030?l00?oooooooooo07Sooooo000Looooo`0300000?l0003ooooo08Go
oooo00<0o`00ooooooooool0NOooool001cooooo00<00000ooooooooool0Q?ooool00`3o003ooooo
ooooo`1jooooo`007?ooool00`00003oooooooooo`23ooooo`030?l00?oooooooooo07_ooooo000L
ooooo`0300000?oooooooooo08;ooooo00<0o`00ooooooooool0O?ooool001cooooo00<00000oooo
ooooool0POooool00`3o003oooooooooo`1mooooo`007?ooool00`00003oooooooooo`21ooooo`03
0?l00?oooooooooo07gooooo000Looooo`0300000?oooooooooo083ooooo00<0o`00ooooooooool0
O_ooool001cooooo00<00000o`000?ooool0Ooooool00`3o003oooooooooo`1oooooo`007?ooool0
0`00003oooooooooo`1nooooo`030?l00?oooooooooo083ooooo000Looooo`0300000?oooooooooo
07gooooo00<0o`00ooooooooool0POooool001cooooo00<00000ooooooooool0O?ooool00`3o003o
ooooooooo`22ooooo`003Oooool00ol0003oooooooooo`02ooooo`Co00001_ooool00`00003ooooo
ooooo`1kooooo`030?l00?oooooooooo08?ooooo000=ooooo`05o`000?ooooooooooooooool00000
1?ooool00ol0003oooooooooo`03ooooo`0300000?oooooooooo07[ooooo00<0o`00ooooooooool0
Q?ooool000gooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`03ooooo`<00000N_oo
ool00`3o003oooooooooo`24ooooo`000oooool7o`0000?ooooo00?o0000ooooooooool01_ooool0
0ol0003oooooooooo`03ooooo`0300000?oooooooooo07Wooooo00<0o`00ooooooooool0QOooool0
00gooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00?ooooo00<00000
ooooooooool0N?ooool00`3o003oooooooooo`26ooooo`003Oooool01?l0003oooooooooooooool5
o`0000Kooooo00<00000ooooooooool0Moooool00`3o003oooooooooo`27ooooo`002oooool3o`00
00?ooooo00?o0000ooooooooool02?ooool00`00003oooooooooo`1fooooo`030?l00?oooooooooo
08Sooooo000=ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01oooool00`00003o
ooooooooo`1fooooo`030?l00?oooooooooo08Sooooo000=ooooo`03o`000?oooooooooo00;ooooo
1Ol00005ooooo`0300000?oooooooooo07Gooooo00<0o`00ooooooooool0ROooool001cooooo00<0
0000o`000?ooool0M?ooool00`3o003oooooooooo`2:ooooo`007?ooool00`00003oooooooooo`1c
ooooo`030?l00?oooooooooo08_ooooo000Looooo`0300000?oooooooooo07;ooooo00<0o`00oooo
ooooool0S?ooool001cooooo00<00000ooooooooool0LOooool00`3o003oooooooooo`2=ooooo`00
7?ooool00`00003oooooooooo`1aooooo`030?l00?oooooooooo08gooooo000Looooo`0300000?oo
oooooooo073ooooo00<0o`00ooooooooool0S_ooool001cooooo00<00000o`000?ooool0Koooool0
0`3o003oooooooooo`2?ooooo`007?ooool00`00003oooooooooo`1^ooooo`030?l00?oooooooooo
093ooooo000Looooo`0300000?oooooooooo06gooooo00<0o`00ooooooooool0TOooool001cooooo
00<00000ooooooooool0KOooool00`3o003oooooooooo`2Aooooo`007?ooool00`00003ooooooooo
o`1/ooooo`030?l00?oooooooooo09;ooooo000Looooo`0300000?oooooooooo06_ooooo00<0o`00
ooooooooool0Toooool001cooooo00<00000ooooooooool0J_ooool00`3o003oooooooooo`2Doooo
o`007?ooool00`00003o0000ooooo`1Yooooo`030?l00?oooooooooo09Gooooo000Looooo`030000
0?oooooooooo06Sooooo00<0o`00ooooooooool0U_ooool001cooooo00<00000ooooooooool0Iooo
ool00`3o003oooooooooo`2Gooooo`007?ooool00`00003oooooooooo`1Vooooo`030?l00?oooooo
oooo09Sooooo000Looooo`0300000?oooooooooo06Kooooo00<0o`00ooooooooool0V?ooool001co
oooo00<00000ooooooooool0IOooool00`3o003oooooooooo`2Iooooo`007?ooool00`00003ooooo
ooooo`1Tooooo`030?l00?oooooooooo09[ooooo000Looooo`0300000?l0003ooooo06?ooooo00<0
o`00ooooooooool0Voooool001cooooo00<00000ooooooooool0H_ooool00`3o003oooooooooo`2L
ooooo`007?ooool00`00003oooooooooo`1Qooooo`030?l00?oooooooooo09gooooo000Looooo`03
00000?oooooooooo063ooooo00<0o`00ooooooooool0W_ooool000gooooo00?o0000ooooooooool0
0_ooool4o`0000Kooooo00<00000ooooooooool0H?ooool00`3o003oooooooooo`2Nooooo`003Ooo
ool01Ol0003ooooooooooooooooo000000Cooooo00?o0000ooooooooool00oooool00`00003ooooo
ooooo`1Oooooo`030?l00?oooooooooo09oooooo000=ooooo`05o`000?ooooooooooooooool00000
1?ooool00ol0003oooooooooo`03ooooo`<00000G_ooool00`3o003oooooooooo`2Pooooo`000ooo
ool7o`0000?ooooo00Go0000ooooooooooooooooo`000004ooooo`03o`000?oooooooooo00?ooooo
00<00000ooooooooool0GOooool00`3o003oooooooooo`2Qooooo`003Oooool01Ol0003ooooooooo
oooooooo000000Cooooo00?o0000ooooooooool00oooool00`00003oooooooooo`1Mooooo`030?l0
0?oooooooooo0:7ooooo000=ooooo`05o`000?ooooooooooooooool000001?ooool00ol0003ooooo
ooooo`03ooooo`0300000?oooooooooo05cooooo00<0o`00ooooooooool0X_ooool000_ooooo0ol0
0003ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00oooool00`00003ooooooooo
o`1Kooooo`030?l00?oooooooooo0:?ooooo000=ooooo`05o`000?ooooooooooooooool000001?oo
ool00ol0003oooooooooo`03ooooo`0300000?oooooooooo05[ooooo00<0o`00ooooooooool0Y?oo
ool000gooooo00?o0000ooooooooool00_ooool4o`0000Kooooo00<00000ooooooooool0FOooool0
0`3o003oooooooooo`2Uooooo`007?ooool00`00003o0000ooooo`1Iooooo`030?l00?oooooooooo
0:Gooooo000Looooo`0300000?oooooooooo05Sooooo00<0o`00ooooooooool0Y_ooool001cooooo
00<00000ooooooooool0Eoooool00`3o003oooooooooo`2Wooooo`007?ooool00`00003ooooooooo
o`1Fooooo`030?l00?oooooooooo0:Sooooo000Looooo`0300000?oooooooooo05Kooooo00?oo`00
ooooooooool0Z?ooool001cooooo00<00000ooooooooool0EOooool00ooo003oooooooooo`2Yoooo
o`007?ooool00`00003o0000ooooo`1Dooooo`03ool00?oooooooooo0:[ooooo000Looooo`030000
0?oooooooooo05?ooooo00?oo`00ooooooooool0Zoooool001cooooo00<00000ooooooooool0D_oo
ool00ooo003oooooooooo`2/ooooo`007?ooool00`00003oooooooooo`1Aooooo`03ool00?oooooo
oooo0:gooooo000Looooo`0300000?oooooooooo053ooooo00?oo`00ooooooooool0[_ooool001co
oooo00<00000ooooooooool0Coooool00ooo003oooooooooo`2_ooooo`007?ooool00`00003ooooo
ooooo`1>ooooo`03ool00?oooooooooo0;3ooooo000Looooo`0300000?l0003ooooo04gooooo00?o
o`00ooooooooool0/Oooool001cooooo00<00000ooooooooool0C?ooool00ooo003oooooooooo`2b
ooooo`007?ooool00`00003oooooooooo`1<ooooo`03ool00?oooooooooo0;;ooooo000Looooo`03
00000?oooooooooo04_ooooo00?oo`00ooooooooool0/oooool001cooooo00<00000ooooooooool0
B_ooool00ooo003oooooooooo`2dooooo`007?ooool00`00003oooooooooo`19ooooo`03ool00?oo
oooooooo0;Gooooo000Looooo`0300000?l0003ooooo04Sooooo00?oo`00ooooooooool0]_ooool0
01cooooo00<00000ooooooooool0Aoooool00ooo003oooooooooo`2gooooo`007?ooool00`00003o
ooooooooo`17ooooo`03ool00?oooooooooo0;Oooooo000Looooo`0300000?oooooooooo04Kooooo
00?oo`00ooooooooool0^?ooool001cooooo00<00000ooooooooool0AOooool00ooo003ooooooooo
o`2iooooo`004Oooool4o`0000Oooooo00<00000ooooooooool0A?ooool00ooo003oooooooooo`2j
ooooo`004?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Cooooo00<00000oooo
ooooool0@oooool00ooo003oooooooooo`2kooooo`005Oooool00ol0003oooooooooo`04ooooo`<0
0000@oooool00ooo003oooooooooo`2kooooo`002Oooool7o`0000Gooooo00?o0000ooooooooool0
1?ooool00`00003oooooooooo`12ooooo`03ool00?oooooooooo0;cooooo000@ooooo`03o`000?oo
oooooooo00;ooooo00?o0000ooooooooool01?ooool00`00003oooooooooo`11ooooo`03ool00?oo
oooooooo0;gooooo000@ooooo`Go00001oooool00`00003oooooooooo`10ooooo`03ool00?oooooo
oooo0;kooooo000@ooooo`03o`000?oooooooooo00Wooooo00<00000ooooooooool0?oooool00ooo
003oooooooooo`2oooooo`004Oooool00ol0003oooooooooo`08ooooo`0300000?oooooooooo03ko
oooo00?oo`00ooooooooool0`?ooool0017ooooo1Ol00006ooooo`0300000?l0003ooooo03gooooo
00?oo`00ooooooooool0`Oooool001cooooo00<00000ooooooooool0??ooool00ooo003ooooooooo
o`32ooooo`007?ooool00`00003oooooooooo`0looooo`03ool00?oooooooooo0<;ooooo000Loooo
o`0300000?oooooooooo03_ooooo00?oo`00ooooooooool0`oooool001cooooo00<00000oooooooo
ool0>_ooool00ooo003oooooooooo`34ooooo`007?ooool00`00003oooooooooo`0iooooo`03ool0
0?oooooooooo0<Gooooo000Looooo`0300000?oooooooooo03Sooooo00?oo`00ooooooooool0a_oo
ool001cooooo00<00000o`000?ooool0=oooool00ooo003oooooooooo`37ooooo`007?ooool00`00
003oooooooooo`0fooooo`03ool00?oooooooooo0<Sooooo000Looooo`0300000?oooooooooo03Go
oooo00?oo`00ooooooooool0bOooool001cooooo00<00000ooooooooool0=?ooool00ooo003ooooo
ooooo`3:ooooo`007?ooool00`00003oooooooooo`0cooooo`03ool00?oooooooooo0<_ooooo000L
ooooo`0300000?oooooooooo03;ooooo00?oo`00ooooooooool0c?ooool001cooooo0ooo000aoooo
o`03ool00?oooooooooo0<gooooo000Looooo`0300000?l0003oo`0000Coo`009?ooool4o`0000?o
oooo00?o0000ool00?ooool01?l0000Zooooo`03o`000?oooooooooo02[ooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`04o`0002Oooooo1_l0000Wooooo`Ko00000_ooool00ol0003o
ooooooooo`04o`0000Gooooo000Looooo`0300000?oooooooooo00Cooooo0ooo000Pooooo`03o`00
0?oooooooooo00;ooooo00Ko0000ooooooooooooo`00ooooool00004ooooo`03o`000?oooooooooo
02Oooooo00?o0000ooooooooool0:_ooool00ol0003oooooooooo`04ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool09?ooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`007?ooool00`00003o
ooooooooo`07ooooo`?oo`007Oooool00ol0003oooooooooo`02ooooo`03o`000?ooooooo`0000Oo
oooo00?o0000ooooooooool09oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Wo
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00_o
oooo00?o0000ooooooooool00_ooool001cooooo00<00000ooooooooool02_ooool2ool001_ooooo
00?o0000ooooooooool00_ooool00ol0003oo`00ooooo`07ooooo`03o`000?oooooooooo02Oooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo02Kooooo
0_l0000[ooooo`;o00002oooool00ol0003oooooooooo`02ooooo`007?ooool00`00003ooooooooo
o`0<ooooo`03ool00?oooooooooo01Sooooo00?o0000ooooooooool00_ooool00ooo003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool09oooool00ol0003ooooooooo
o`0Zooooo`03o`000?oooooooooo00Cooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`0Xooooo`03o`000?oooooooooo02[ooooo00?o0000ooooooooool00oooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00;ooooo000Looooo`0300000?oooooooooo00gooooo0_oo000H
ooooo`06o`000?oooooooooooooooooo003o00001?ooool5o`0002[ooooo00?o0000ooooooooool0
:_ooool00ol0003oooooooooo`04ooooo`Go0000;?ooool00ol0003oooooooooo`0Zooooo`03o`00
0?oooooooooo00;ooooo1Ol00005ooooo`007?ooool00`00003o0000ooooo`0?ooooo`03ool00?oo
oooooooo01Gooooo00Ko0000oooooooo003oo`00ooooool00004ooooo`03o`000?oooooooooo02[o
oooo0ol0000Zooooo`?o00001_ooool00ol0003oooooooooo`0Yooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool09Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool01oooool001cooooo00<00000ooooooooool04?ooool00ooo003ooooo
ooooo`0Dooooo`;oo`000oooool00ol0003oooooooooo`03ooooo`03o`000?oooooooooo02_ooooo
00?o0000ooooooooool0:_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo02Sooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Uooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool00oooool00ol0003oooooooooo`06ooooo`007?ooool00`00003ooooooooo
o`0Aooooo`03ool00?oooooooooo01;ooooo00?oo`00ooooool000000ol00006ooooo`Go0000:Ooo
ool00ol0003oooooooooo`0Zooooo`03o`000?oooooooooo00Gooooo1Ol0000Wooooo`Co0000:Ooo
ool4o`0000Kooooo1Ol00004ooooo`007?ooool00`00003oooooooooo`0Booooo`03ool00?oooooo
oooo00oooooo0_oo003Kooooo`007?ooool00`00003oooooooooo`0Cooooo`;oo`003?ooool3ool0
0=gooooo000Looooo`0300000?oooooooooo01Gooooo00?oo`00ooooooooool01oooool2ool00>3o
oooo000Looooo`0300000?oooooooooo01Kooooo0ooo0005ooooo`03ool00?oooooooooo0>3ooooo
000Fooooob8000001Ooo003N000000Gooooo000Looooo`0300000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Kooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Oooooo00?o0000
ooooooooool02Oooool001cooooo00<00000ooooooooool0ooooool2ooooo`007?ooool00`00003o
ooooooooo`3oooooo`;ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003ooooo
ob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo003oooooob7ooooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.289916, -25.1803, \
0.0100821, 0.152526}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[g1, g2, PlotRange \[Rule] {{0, 0.7}, {0, \(-4\)}}]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12  scalefont  setfont
% Scaling calculations
0 1.42857 0.618034 0.154508 [
[.14286 .60553 -10.2812 -14 ]
[.14286 .60553 10.2812 0 ]
[.28571 .60553 -10.2812 -14 ]
[.28571 .60553 10.2812 0 ]
[.42857 .60553 -10.2812 -14 ]
[.42857 .60553 10.2812 0 ]
[.57143 .60553 -10.2812 -14 ]
[.57143 .60553 10.2812 0 ]
[.71429 .60553 -10.2812 -14 ]
[.71429 .60553 10.2812 0 ]
[.85714 .60553 -10.2812 -14 ]
[.85714 .60553 10.2812 0 ]
[-0.0125 0 -18.875 -7 ]
[-0.0125 0 0 7 ]
[-0.0125 .07725 -28.8125 -7 ]
[-0.0125 .07725 0 7 ]
[-0.0125 .15451 -18.875 -7 ]
[-0.0125 .15451 0 7 ]
[-0.0125 .23176 -28.8125 -7 ]
[-0.0125 .23176 0 7 ]
[-0.0125 .30902 -18.875 -7 ]
[-0.0125 .30902 0 7 ]
[-0.0125 .38627 -28.8125 -7 ]
[-0.0125 .38627 0 7 ]
[-0.0125 .46353 -18.875 -7 ]
[-0.0125 .46353 0 7 ]
[-0.0125 .54078 -28.8125 -7 ]
[-0.0125 .54078 0 7 ]
[ 0 0 0 0 ]
[ 1 .62428 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.14286 .61803 m
.14286 .62428 L
s
gsave
.14286 .60553 -71.2812 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.1) show
1.000 setlinewidth
grestore
.28571 .61803 m
.28571 .62428 L
s
gsave
.28571 .60553 -71.2812 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.2) show
1.000 setlinewidth
grestore
.42857 .61803 m
.42857 .62428 L
s
gsave
.42857 .60553 -71.2812 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.3) show
1.000 setlinewidth
grestore
.57143 .61803 m
.57143 .62428 L
s
gsave
.57143 .60553 -71.2812 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.4) show
1.000 setlinewidth
grestore
.71429 .61803 m
.71429 .62428 L
s
gsave
.71429 .60553 -71.2812 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.85714 .61803 m
.85714 .62428 L
s
gsave
.85714 .60553 -71.2812 -18 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.6) show
1.000 setlinewidth
grestore
.125 Mabswid
.02857 .61803 m
.02857 .62178 L
s
.05714 .61803 m
.05714 .62178 L
s
.08571 .61803 m
.08571 .62178 L
s
.11429 .61803 m
.11429 .62178 L
s
.17143 .61803 m
.17143 .62178 L
s
.2 .61803 m
.2 .62178 L
s
.22857 .61803 m
.22857 .62178 L
s
.25714 .61803 m
.25714 .62178 L
s
.31429 .61803 m
.31429 .62178 L
s
.34286 .61803 m
.34286 .62178 L
s
.37143 .61803 m
.37143 .62178 L
s
.4 .61803 m
.4 .62178 L
s
.45714 .61803 m
.45714 .62178 L
s
.48571 .61803 m
.48571 .62178 L
s
.51429 .61803 m
.51429 .62178 L
s
.54286 .61803 m
.54286 .62178 L
s
.6 .61803 m
.6 .62178 L
s
.62857 .61803 m
.62857 .62178 L
s
.65714 .61803 m
.65714 .62178 L
s
.68571 .61803 m
.68571 .62178 L
s
.74286 .61803 m
.74286 .62178 L
s
.77143 .61803 m
.77143 .62178 L
s
.8 .61803 m
.8 .62178 L
s
.82857 .61803 m
.82857 .62178 L
s
.88571 .61803 m
.88571 .62178 L
s
.91429 .61803 m
.91429 .62178 L
s
.94286 .61803 m
.94286 .62178 L
s
.97143 .61803 m
.97143 .62178 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
0 0 m
.00625 0 L
s
gsave
-0.0125 0 -79.875 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
0 .07725 m
.00625 .07725 L
s
gsave
-0.0125 .07725 -89.8125 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3.5) show
1.000 setlinewidth
grestore
0 .15451 m
.00625 .15451 L
s
gsave
-0.0125 .15451 -79.875 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
0 .23176 m
.00625 .23176 L
s
gsave
-0.0125 .23176 -89.8125 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2.5) show
1.000 setlinewidth
grestore
0 .30902 m
.00625 .30902 L
s
gsave
-0.0125 .30902 -79.875 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
0 .38627 m
.00625 .38627 L
s
gsave
-0.0125 .38627 -89.8125 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1.5) show
1.000 setlinewidth
grestore
0 .46353 m
.00625 .46353 L
s
gsave
-0.0125 .46353 -79.875 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
0 .54078 m
.00625 .54078 L
s
gsave
-0.0125 .54078 -89.8125 -11 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 22 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 14.000 moveto
%%IncludeResource: font Mathematica1
%%IncludeFont: Mathematica1
/Mathematica1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
71.250 14.000 moveto
%%IncludeResource: font Helvetica
%%IncludeFont: Helvetica
/Helvetica findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
1.000 setlinewidth
grestore
.125 Mabswid
0 .01545 m
.00375 .01545 L
s
0 .0309 m
.00375 .0309 L
s
0 .04635 m
.00375 .04635 L
s
0 .0618 m
.00375 .0618 L
s
0 .09271 m
.00375 .09271 L
s
0 .10816 m
.00375 .10816 L
s
0 .12361 m
.00375 .12361 L
s
0 .13906 m
.00375 .13906 L
s
0 .16996 m
.00375 .16996 L
s
0 .18541 m
.00375 .18541 L
s
0 .20086 m
.00375 .20086 L
s
0 .21631 m
.00375 .21631 L
s
0 .24721 m
.00375 .24721 L
s
0 .26266 m
.00375 .26266 L
s
0 .27812 m
.00375 .27812 L
s
0 .29357 m
.00375 .29357 L
s
0 .32447 m
.00375 .32447 L
s
0 .33992 m
.00375 .33992 L
s
0 .35537 m
.00375 .35537 L
s
0 .37082 m
.00375 .37082 L
s
0 .40172 m
.00375 .40172 L
s
0 .41717 m
.00375 .41717 L
s
0 .43262 m
.00375 .43262 L
s
0 .44807 m
.00375 .44807 L
s
0 .47898 m
.00375 .47898 L
s
0 .49443 m
.00375 .49443 L
s
0 .50988 m
.00375 .50988 L
s
0 .52533 m
.00375 .52533 L
s
0 .55623 m
.00375 .55623 L
s
0 .57168 m
.00375 .57168 L
s
0 .58713 m
.00375 .58713 L
s
0 .60258 m
.00375 .60258 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.5 Mabswid
.12155 0 m
.12732 .01612 L
.14286 .06034 L
.16029 .11132 L
.17985 .17057 L
.20179 .23936 L
.22641 .31699 L
.25404 .39893 L
.28504 .47737 L
.31982 .54404 L
.35884 .59236 L
.40263 .61793 L
.45175 .61803 L
.50688 .59103 L
.56872 .53586 L
.63812 .45177 L
.71598 .33814 L
.80334 .19431 L
.90137 .01955 L
s
.90137 .01955 m
.91178 0 L
s
1 0 0 r
1e-05 .29732 m
2e-05 .29732 L
2e-05 .29732 L
2e-05 .29732 L
2e-05 .29732 L
3e-05 .29733 L
3e-05 .29733 L
3e-05 .29733 L
4e-05 .29733 L
4e-05 .29733 L
5e-05 .29733 L
5e-05 .29733 L
6e-05 .29734 L
6e-05 .29734 L
7e-05 .29734 L
8e-05 .29734 L
9e-05 .29735 L
.0001 .29735 L
.00011 .29736 L
.00013 .29736 L
.00014 .29737 L
.00016 .29737 L
.00018 .29738 L
.0002 .29739 L
.00023 .2974 L
.00025 .29741 L
.00029 .29742 L
.00032 .29743 L
.00036 .29744 L
.0004 .29746 L
.00045 .29747 L
.00051 .29749 L
.00057 .29751 L
.00064 .29754 L
.00072 .29757 L
.0008 .2976 L
.0009 .29763 L
.00101 .29767 L
.00113 .29771 L
.00127 .29776 L
.00143 .29782 L
.0016 .29788 L
.0018 .29794 L
.00202 .29802 L
.00226 .29811 L
.00254 .2982 L
.00285 .29831 L
.0032 .29843 L
.00359 .29857 L
.00403 .29873 L
Mistroke
.00452 .2989 L
.00507 .29909 L
.00569 .29931 L
.00638 .29956 L
.00716 .29983 L
.00803 .30014 L
.00901 .30049 L
.01011 .30088 L
.01135 .30132 L
.01273 .30182 L
.01429 .30238 L
.01603 .30301 L
.01798 .30373 L
.02018 .30453 L
.02264 .30543 L
.0254 .30646 L
.0285 .30762 L
.03198 .30893 L
.03588 .31042 L
.04026 .31211 L
.04518 .31403 L
.05069 .31622 L
.05687 .31872 L
.06381 .32159 L
.0716 .32488 L
.08033 .32868 L
.09014 .33307 L
.10114 .3382 L
.11348 .34422 L
.12732 .35136 L
.14286 .35994 L
.16029 .3705 L
.17985 .38399 L
.20179 .40227 L
.22641 .42834 L
.25404 .46494 L
.28504 .51065 L
.31982 .55794 L
.35884 .59658 L
.40263 .61803 L
.45175 .61681 L
.50688 .58972 L
.56872 .53496 L
.63812 .45143 L
.71598 .33833 L
.80334 .19494 L
.90137 .02052 L
Mfstroke
.90137 .02052 m
.91231 0 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003ooooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQ
ooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`00oooooolQooooo`006?ooool0
0ol0003oooooooooo`3oooooo`Kooooo000Hooooo`03o`000?oooooooooo0?oooooo1_ooool001Co
oooo1_l00006ooooo`0300000?l0003ooooo01_ooooo00<00000ooooooooool0aoooool00`3o003o
ooooooooo`0Eooooo`003?ooool7o`000003ooooool0003ooooo00;ooooo00?o0000ooooooooool0
1Oooool00`00003oooooooooo`0Kooooo`0300000?oooooooooo0<Oooooo00<0o`00ooooooooool0
5Oooool001Gooooo00Co0000oooooooooooo00001oooool00`00003oooooooooo`0Looooo`030000
0?oooooooooo0<Gooooo00<0o`00ooooooooool05_ooool001Kooooo00?o0000ooooool000001ooo
ool00`00003oooooooooo`0Looooo`0300000?oooooooooo0<Cooooo00<0o`00ooooooooool05ooo
ool001Kooooo00?o0000ooooool000001oooool00`00003oooooooooo`0Mooooo`0300000?oooooo
oooo0<?ooooo00<0o`00ooooooooool05oooool001Oooooo0_l00007ooooo`0300000?oooooooooo
01gooooo00<00000ooooooooool0`_ooool00`3o003oooooooooo`0Hooooo`006?ooool00ol0003o
ooooooooo`05ooooo`0300000?oooooooooo01kooooo00<00000ooooooooool0`Oooool00`3o003o
ooooooooo`0Hooooo`008?ooool00`00003oooooooooo`0Nooooo`0300000?oooooooooo0<3ooooo
00<0o`00ooooooooool06Oooool0023ooooo00<00000ooooooooool07_ooool00`00003ooooooooo
o`30ooooo`030?l00?oooooooooo01Wooooo000Pooooo`0300000?oooooooooo01oooooo00<00000
ooooooooool0__ooool00`3o003oooooooooo`0Jooooo`008?ooool00`00003oooooooooo`0Ooooo
o`0300000?oooooooooo0;gooooo00<0o`00ooooooooool06oooool0023ooooo00<00000oooooooo
ool07oooool00`00003oooooooooo`2mooooo`030?l00?oooooooooo01_ooooo000Pooooo`030000
0?oooooooooo023ooooo00<00000ooooooooool0^oooool00`3o003oooooooooo`0Looooo`008?oo
ool00`00003oooooooooo`0Pooooo`0300000?oooooooooo0;_ooooo00<0o`00ooooooooool07?oo
ool0023ooooo00<00000ooooooooool08?ooool00`00003oooooooooo`2jooooo`030?l00?oooooo
oooo01gooooo000Pooooo`0300000?oooooooooo027ooooo00<00000ooooooooool0^Oooool00`3o
003oooooooooo`0Mooooo`008?ooool00`00003oooooooooo`0Qooooo`0300000?oooooooooo0;So
oooo00<0o`00ooooooooool07_ooool0023ooooo00<00000ooooooooool08Oooool00`00003ooooo
ooooo`2gooooo`030000003o003ooooo01oooooo000;ooooo`Co00000oooool00ol0003ooooooooo
o`04o`0000Oooooo00<00000ooooooooool08_ooool00`00003oooooooooo`2fooooo`030?l00?oo
oooooooo01oooooo000:ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool0
0ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Cooooo00<00000ooooooooool08_ooool0
0`00003oooooooooo`2eooooo`030?l00?oooooooooo023ooooo000:ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`04ooooo`0300000?l0003ooooo
02;ooooo00<00000ooooooooool0]Oooool00`3o003oooooooooo`0Pooooo`000oooool7o`0000Go
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`04ooooo`0300000?oooooooooo02?o
oooo00<00000ooooooooool0/oooool00`3o003oooooooooo`0Qooooo`003?ooool3o`0000Gooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`04ooooo`0300000?oooooooooo02?ooooo
00<00000ooooooooool0/oooool00`3o003oooooooooo`0Qooooo`003oooool00ol0003ooooooooo
o`02ooooo`Go00001oooool00`00003oooooooooo`0Sooooo`0300000?oooooooooo0;;ooooo00<0
o`00ooooooooool08_ooool000[ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00Wooooo00<00000ooooooooool09?ooool00`00003oooooooooo`2`
ooooo`030000003o003ooooo02?ooooo000:ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00oooool00ol0003oooooooooo`08ooooo`0300000?oooooooooo02Cooooo00<00000oooo
ooooool0/?ooool00`3o003oooooooooo`0Sooooo`002oooool4o`0000Kooooo1Ol00006ooooo`03
00000?oooooooooo02Cooooo00<00000ooooooooool0[oooool00`000000o`00ooooo`0Tooooo`00
8?ooool00`00003oooooooooo`0Uooooo`0300000?oooooooooo0:kooooo00<0o`00ooooooooool0
9?ooool0023ooooo00<00000ooooooooool09Oooool00`00003oooooooooo`2]ooooo`030?l00?oo
oooooooo02Gooooo000Pooooo`0300000?oooooooooo02Gooooo00<00000ooooooooool0[Oooool0
0`3o003oooooooooo`0Uooooo`008?ooool00`00003oooooooooo`0Vooooo`0300000?oooooooooo
0:_ooooo00<0o`00ooooooooool09_ooool0023ooooo00<00000ooooooooool09_ooool00`00003o
ooooooooo`2[ooooo`030?l00?oooooooooo02Kooooo000Pooooo`0300000?oooooooooo02Kooooo
00<00000ooooooooool0Z_ooool00`3o003oooooooooo`0Wooooo`008?ooool00`00003ooooooooo
o`0Wooooo`0300000?oooooooooo0:Sooooo00<000000?l00?ooool0:?ooool0023ooooo00<00000
ooooooooool09oooool00`00003oooooooooo`2Xooooo`030?l00?oooooooooo02Sooooo000Poooo
o`0300000?oooooooooo02Oooooo00<00000ooooooooool0Yoooool00`000000o`00ooooo`0Yoooo
o`008?ooool00`00003oooooooooo`0Xooooo`0300000?oooooooooo0:Kooooo00<0o`00oooooooo
ool0:Oooool001Gooooo1?l00007ooooo`0300000?oooooooooo02Sooooo00<00000ooooooooool0
YOooool00`3o003oooooooooo`0Zooooo`005?ooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00Cooooo00<00000ooooooooool0:?ooool00`00003oooooooooo`2Uooooo`030?l00?oo
oooooooo02[ooooo000Dooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01?ooool0
0`00003o0000ooooo`0Yooooo`0300000?oooooooooo0:?ooooo00<0o`00ooooooooool0:oooool0
00cooooo1ol00006ooooo`03o`000?oooooooooo00Cooooo00<00000ooooooooool0:Oooool00`00
003oooooooooo`2Rooooo`030000003o003ooooo02cooooo000Fooooo`?o00001oooool00`00003o
ooooooooo`0Yooooo`0300000?oooooooooo0:;ooooo00<0o`00ooooooooool0;?ooool001Wooooo
00?o0000ooooooooool01?ooool00`00003oooooooooo`0Zooooo`0300000?oooooooooo0:3ooooo
00<000000?l00?ooool0;Oooool001Cooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`04ooooo`0300000?oooooooooo02[ooooo00<00000ooooooooool0X?ooool00`3o003ooooooooo
o`0]ooooo`005?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Cooooo00<00000
ooooooooool0:_ooool00`00003oooooooooo`2Oooooo`030000003o003ooooo02kooooo000Eoooo
o`Co00001oooool00`00003oooooooooo`0[ooooo`0300000?oooooooooo09kooooo00<0o`00oooo
ooooool0;_ooool0023ooooo00<00000ooooooooool0:oooool00`00003oooooooooo`2Mooooo`03
0?l00?oooooooooo02oooooo000Pooooo`0300000?oooooooooo02_ooooo00<00000ooooooooool0
W?ooool00`000000o`00ooooo`0`ooooo`008?ooool00`00003oooooooooo`0/ooooo`0300000?oo
oooooooo09_ooooo00<0o`00ooooooooool0<?ooool0023ooooo00<00000ooooooooool0;?ooool0
0`00003oooooooooo`2Jooooo`030000003o003ooooo037ooooo000Pooooo`0300000?oooooooooo
02cooooo00<00000ooooooooool0V_ooool00`3o003oooooooooo`0aooooo`008?ooool00`00003o
ooooooooo`0]ooooo`0300000?oooooooooo09Sooooo00<000000?l00?ooool0<_ooool0023ooooo
00<00000ooooooooool0;Oooool00`00003oooooooooo`2Hooooo`030?l00?oooooooooo03;ooooo
000Pooooo`0300000?oooooooooo02gooooo00<00000ooooooooool0Uoooool00`3o003ooooooooo
o`0cooooo`008?ooool00`00003oooooooooo`0^ooooo`0300000?oooooooooo09Gooooo00<00000
0?l00?ooool0=?ooool0023ooooo00<00000ooooooooool0;_ooool00`00003oooooooooo`2Eoooo
o`030?l00?oooooooooo03Cooooo000Pooooo`0300000?oooooooooo02kooooo00<00000oooooooo
ool0U?ooool00`000000o`00ooooo`0eooooo`002_ooool6o`0000;ooooo00?o0000ooooooooool0
1?l00007ooooo`0300000?oooooooooo02oooooo00<00000ooooooooool0Toooool00`3o003ooooo
ooooo`0eooooo`002_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00;ooooo00?o
0000ooooooooool01?ooool00`00003oooooooooo`0_ooooo`0300000?oooooooooo09;ooooo00<0
o`00ooooooooool0=_ooool000_ooooo00?o0000ooooooooool02oooool00ol0003oooooooooo`04
ooooo`0300000?l0003ooooo02oooooo00<00000ooooooooool0TOooool00`000000o`00ooooo`0g
ooooo`000oooool7o`0000;ooooo0_l0000;ooooo`03o`000?oooooooooo00Cooooo00<00000oooo
ooooool0<?ooool00`00003oooooooooo`2@ooooo`030?l00?oooooooooo03Oooooo000>ooooo`03
o`000?oooooooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`04ooooo`03
00000?oooooooooo033ooooo00<00000ooooooooool0Soooool00`000000o`00ooooo`0hooooo`00
3oooool00ol0003oooooooooo`02ooooo`Go00001oooool00`00003oooooooooo`0`ooooo`030000
0?oooooooooo08oooooo00<0o`00ooooooooool0>?ooool000[ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo00<00000ooooooooool0<?oo
ool00`00003oooooooooo`2>ooooo`030?l00?oooooooooo03Wooooo000:ooooo`03o`000?oooooo
oooo00;ooooo00?o0000ooooooooool00oooool00ol0003oooooooooo`08ooooo`0300000?oooooo
oooo037ooooo00<00000ooooooooool0S?ooool00`000000o`00ooooo`0jooooo`002oooool4o`00
00Kooooo1Ol00006ooooo`0300000?oooooooooo037ooooo00<00000ooooooooool0S?ooool00`3o
003oooooooooo`0jooooo`008?ooool00`00003oooooooooo`0aooooo`0300000?oooooooooo08_o
oooo00<000000?l00?ooool0>oooool0023ooooo00<00000ooooooooool0<_ooool00`00003ooooo
ooooo`2:ooooo`030?l00?oooooooooo03_ooooo000Pooooo`0300000?oooooooooo03;ooooo00<0
0000ooooooooool0ROooool00`3o003oooooooooo`0looooo`008?ooool00`00003oooooooooo`0b
ooooo`0300000?oooooooooo08Sooooo00<000000?l00?ooool0?Oooool0023ooooo00<00000oooo
ooooool0<oooool00`00003oooooooooo`27ooooo`030?l00?oooooooooo03gooooo000Pooooo`03
00000?oooooooooo03?ooooo00<00000ooooooooool0Q_ooool00`3o003oooooooooo`0nooooo`00
8?ooool00`00003oooooooooo`0cooooo`0300000?oooooooooo08Kooooo00<0o`00ooooooooool0
?_ooool0023ooooo00<00000ooooooooool0<oooool00`00003oooooooooo`25ooooo`030?l00?oo
oooooooo03oooooo000Pooooo`0300000?oooooooooo03Cooooo00<00000ooooooooool0Poooool0
0`000000o`00ooooo`10ooooo`008?ooool00`00003oooooooooo`0dooooo`0300000?oooooooooo
08?ooooo00<0o`00ooooooooool0@?ooool0023ooooo0ooo000dooooo`0300000?oooooooooo08;o
oooo00<0o`00ooooooooool0@Oooool001Cooooo1_l00006ooooo`0300000?ooooooo`0000;oo`00
<oooool00`00003oooooooooo`21ooooo`030?l00?oooooooooo047ooooo000Dooooo`03o`000?oo
oooooooo00Wooooo00<00000ooooooooool00_ooool3ool0033ooooo00<00000ooooooooool0P?oo
ool00`3o003oooooooooo`12ooooo`005Oooool00ol0003oooooooooo`08ooooo`0300000?l0003o
oooo00Gooooo0_oo000^ooooo`0300000?oooooooooo07oooooo00<000000?l00?ooool0@oooool0
00cooooo1ol00003ooooo`;o00002?ooool00`00003oooooooooo`07ooooo`;oo`00;Oooool00`00
003oooooooooo`1nooooo`030?l00?oooooooooo04?ooooo000Hooooo`03o`000?oooooooooo00Go
oooo00<00000ooooooooool02Oooool40?l002Wooooo00<00000ooooooooool0OOooool00`3o003o
ooooooooo`14ooooo`006Oooool00ol0003oooooooooo`04ooooo`0300000?oooooooooo00gooooo
0P3o000Wooooo`0300000?oooooooooo07gooooo00<0o`00ooooooooool0A?ooool001Cooooo00?o
0000ooooooooool00_ooool00ol0003oooooooooo`04ooooo`0300000?oooooooooo00oooooo0P3o
000Vooooo`0300000?oooooooooo07_ooooo00<0o`00ooooooooool0AOooool001Cooooo00?o0000
ooooooooool00_ooool00ol0003oooooooooo`04ooooo`0300000?oooooooooo017ooooo0P3o000T
ooooo`0300000?oooooooooo07[ooooo00<000000?l00?ooool0A_ooool001Gooooo1?l00007oooo
o`0300000?oooooooooo01?ooooo0`3o000Qooooo`0300000?oooooooooo07[ooooo00<0o`00oooo
ooooool0A_ooool0023ooooo00<00000ooooooooool05_ooool20?l0023ooooo00<00000oooooooo
ool0N?ooool00`3o003oooooooooo`17ooooo`008?ooool00`00003oooooooooo`0Hooooo`030?l0
0?oooooooooo01gooooo00<00000ooooooooool0N?ooool00`3o003oooooooooo`17ooooo`008?oo
ool00`00003oooooooooo`0Iooooo`80o`007Oooool00`00003oooooooooo`1gooooo`030?l00?oo
oooooooo04Sooooo000Pooooo`0300000?oooooooooo01_ooooo0P3o000Looooo`0300000?oooooo
oooo07Gooooo00<0o`00ooooooooool0BOooool0023ooooo00<00000ooooooooool07Oooool20?l0
01[ooooo00<00000ooooooooool0MOooool00`3o003oooooooooo`19ooooo`008?ooool00`00003o
ooooooooo`0Oooooo`80o`006?ooool00`00003oooooooooo`1dooooo`030?l00?oooooooooo04[o
oooo000Pooooo`0300000?oooooooooo027ooooo0P3o000Gooooo`0300000?oooooooooo07;ooooo
00<0o`00ooooooooool0Boooool0023ooooo00<00000ooooooooool08oooool20?l001Gooooo00<0
0000ooooooooool0L_ooool00`3o003oooooooooo`1;ooooo`008?ooool00`00003oooooooooo`0U
ooooo`80o`004oooool00`00003oooooooooo`1aooooo`030?l00?oooooooooo04cooooo000Poooo
o`0300000?oooooooooo02Oooooo00<0o`00ooooooooool04Oooool00`00003oooooooooo`1_oooo
o`030?l00?oooooooooo04gooooo000=ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool01?l00007ooooo`0300000?oooooooooo02Sooooo00<0o`00ooooooooool04?ooool00`00003o
ooooooooo`1^ooooo`030?l00?oooooooooo04kooooo000=ooooo`03o`000?oooooooooo00Cooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`04ooooo`0300000?oooooooooo02Wooooo
00<0o`00ooooooooool03oooool00`00003oooooooooo`1^ooooo`030?l00?oooooooooo04kooooo
000=ooooo`03o`000?oooooooooo00Wooooo00?o0000ooooooooool01?ooool00`00003o0000oooo
o`0Zooooo`80o`004?ooool00`00003oooooooooo`1/ooooo`030?l00?oooooooooo04oooooo0003
ooooo`Oo00000oooool00ol0003oooooooooo`09ooooo`03o`000?oooooooooo00Cooooo00<00000
ooooooooool0;?ooool00`3o003oooooooooo`0=ooooo`0300000?oooooooooo06_ooooo00<0o`00
ooooooooool0D?ooool000gooooo00?o0000ooooooooool01?ooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00Cooooo00<00000ooooooooool0;Oooool00`3o003oooooooooo`0<oooo
o`0300000?oooooooooo06_ooooo00<0o`00ooooooooool0D?ooool000gooooo00?o0000oooooooo
ool01?ooool5o`0000Oooooo00<00000ooooooooool0;_ooool00`3o003oooooooooo`0<ooooo`03
00000?oooooooooo06Wooooo00<0o`00ooooooooool0DOooool000_ooooo0ol00006ooooo`03o`00
0?oooooooooo00Wooooo00<00000ooooooooool0;oooool00`3o003oooooooooo`0;ooooo`030000
0?oooooooooo06Sooooo00<0o`00ooooooooool0D_ooool000gooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`08ooooo`0300000?oooooooooo033ooooo00<0o`00ooooooooool02_oo
ool00`00003oooooooooo`1Xooooo`030?l00?oooooooooo05;ooooo000=ooooo`03o`000?oooooo
oooo00Gooooo1Ol00006ooooo`0300000?oooooooooo037ooooo00<0o`00ooooooooool02_ooool0
0`00003oooooooooo`1Vooooo`030?l00?oooooooooo05?ooooo000Pooooo`0300000?oooooooooo
03;ooooo00<0o`00ooooooooool02Oooool00`00003oooooooooo`1Uooooo`030?l00?oooooooooo
05Cooooo000Pooooo`0300000?oooooooooo03?ooooo00<0o`00ooooooooool02?ooool00`00003o
ooooooooo`1Uooooo`030?l00?oooooooooo05Cooooo000Pooooo`0300000?oooooooooo03Cooooo
00<0o`00ooooooooool02?ooool00`00003oooooooooo`1Sooooo`030?l00?oooooooooo05Gooooo
000Pooooo`0300000?oooooooooo03Gooooo00<0o`00ooooooooool01oooool00`00003ooooooooo
o`1Rooooo`030?l00?oooooooooo05Kooooo000Pooooo`0300000?oooooooooo03Kooooo00<0o`00
ooooooooool01oooool00`00003oooooooooo`1Pooooo`030?l00?oooooooooo05Oooooo000Poooo
o`0300000?oooooooooo03Kooooo00<0o`00ooooooooool01oooool00`00003oooooooooo`1Poooo
o`030?l00?oooooooooo05Oooooo000Pooooo`0300000?oooooooooo03Oooooo00<0o`00oooooooo
ool01_ooool00`00003oooooooooo`1Oooooo`030?l00?oooooooooo05Sooooo000Pooooo`030000
0?oooooooooo03Sooooo00<0o`00ooooooooool01_ooool00`00003oooooooooo`1Mooooo`030?l0
0?oooooooooo05Wooooo000Pooooo`0300000?oooooooooo03Wooooo00<0o`00ooooooooool01Ooo
ool00`00003oooooooooo`1Mooooo`030?l00?oooooooooo05Wooooo000Pooooo`0300000?oooooo
oooo03[ooooo00<0o`00ooooooooool01Oooool00`00003oooooooooo`1Kooooo`030?l00?oooooo
oooo05[ooooo000Pooooo`0300000?oooooooooo03[ooooo00<0o`00ooooooooool01Oooool00`00
003oooooooooo`1Jooooo`030?l00?oooooooooo05_ooooo000Gooooo`03o`000?oooooooooo00Ko
oooo00<00000ooooooooool0>oooool00`3o003oooooooooo`04ooooo`0300000?oooooooooo05[o
oooo00<0o`00ooooooooool0Foooool001Oooooo00?o0000ooooooooool01_ooool00`00003ooooo
ooooo`0looooo`030?l00?oooooooooo00Cooooo00<00000ooooooooool0F?ooool00`3o003ooooo
ooooo`1Looooo`005oooool00ol0003oooooooooo`06ooooo`0300000?l0003ooooo03gooooo00<0
o`00ooooooooool00oooool00`00003oooooooooo`1Gooooo`030?l00?oooooooooo05gooooo000<
ooooo`Oo00001?ooool00ol0003oooooooooo`06ooooo`0300000?oooooooooo03gooooo00<0o`00
ooooooooool01?ooool00`00003oooooooooo`1Eooooo`030?l00?oooooooooo05kooooo000Goooo
o`03o`000?oooooooooo00Kooooo00<00000ooooooooool0?_ooool00`3o003oooooooooo`03oooo
o`0300000?oooooooooo05Cooooo00<0o`0000000?ooool0Goooool001Oooooo00?o0000oooooooo
ool01_ooool00`00003oooooooooo`0oooooo`030?l00?oooooooooo00;ooooo00<00000oooooooo
ool0E?ooool00`3o003oooooooooo`1Oooooo`005Oooool3o`0000Sooooo00<00000ooooooooool0
?oooool00`3o003oooooooooo`03ooooo`0300000?oooooooooo05;ooooo00<0o`00ooooooooool0
H?ooool001Oooooo00?o0000ooooooooool01_ooool00`00003oooooooooo`10ooooo`030?l00?oo
oooooooo00;ooooo00<00000ooooooooool0DOooool00`3o003oooooooooo`1Qooooo`005oooool0
0ol0003oooooooooo`06ooooo`0300000?oooooooooo047ooooo00<0o`00ooooooooool00_ooool0
0`00003oooooooooo`1?ooooo`030?l00?oooooooooo06;ooooo000Pooooo`0300000?oooooooooo
047ooooo00<0o`00ooooooooool00_ooool00`00003oooooooooo`1>ooooo`030?l00000003ooooo
06?ooooo000Pooooo`0300000?oooooooooo04;ooooo00<0o`00ooooooooool00_ooool00`00003o
ooooooooo`1<ooooo`030?l00000003ooooo06Cooooo000Pooooo`0300000?oooooooooo04?ooooo
00D0o`00oooooooooooooooo0000001>ooooo`030?l00?oooooooooo06Cooooo000Pooooo`030000
0?oooooooooo04?ooooo00<0o`00ooooooooool00_ooool00`00003oooooooooo`1:ooooo`030?l0
0?oooooooooo06Gooooo000Pooooo`0300000?oooooooooo04Cooooo00D0o`00oooooooooooooooo
0000001;ooooo`030?l00000003ooooo06Kooooo000Pooooo`0300000?oooooooooo04Gooooo00D0
o`00oooooooooooooooo00000019ooooo`030?l00000003ooooo06Oooooo000Pooooo`0300000?oo
oooooooo04Gooooo00<0o`00ooooooooool00_ooool00`00003oooooooooo`15ooooo`030?l00000
003ooooo06Sooooo000Pooooo`0300000?oooooooooo04Kooooo00D0o`00oooooooooooooooo0000
0017ooooo`030?l00?oooooooooo06Sooooo000Pooooo`0300000?oooooooooo04Oooooo00D0o`00
oooooooooooooooo00000015ooooo`030?l00?oooooooooo06Wooooo000Pooooo`0300000?oooooo
oooo04Sooooo00@0o`00ooooooooool00000A?ooool00`3o00000000ooooo`1Zooooo`008?ooool0
0`00003oooooooooo`18ooooo`050?l00?ooooooooooooooo`000000@_ooool00`3o00000000oooo
o`1[ooooo`002oooool4o`0000?ooooo00?o0000ooooooooool01?l00007ooooo`0300000?oooooo
oooo04Wooooo00@0o`00ooooooooool00000@?ooool20?l0000300000?oooooooooo06_ooooo000:
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00Cooooo00<00000ooooooooool0B_ooool0103o003oooooooooo`00
000nooooo`030?l000000000000006kooooo000:ooooo`03o`000?oooooooooo00;ooooo00?o0000
ooooooooool01oooool00ol0003oooooooooo`04ooooo`0300000?l0003ooooo04_ooooo00<0o`00
ooooo`000000?Oooool00`3o00000000ooooo`1_ooooo`000oooool8o`0000Cooooo00?o0000oooo
ooooool01oooool00ol0003oooooooooo`04ooooo`0300000?oooooooooo04_ooooo00@0o`00oooo
ooooool00000>oooool00`3o00000000ooooo`1`ooooo`002_ooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`04oooo
o`0300000?oooooooooo04cooooo00<0o`00ooooo`000000>_ooool00`3o00000000ooooo`1aoooo
o`002_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo1Ol00007ooooo`03
00000?oooooooooo04gooooo00<0o`00ooooo`000000>?ooool00`3o00000000ooooo`1booooo`00
2_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool0
2Oooool00`00003oooooooooo`1>ooooo`030?l00?ooool0000003Kooooo00<0o`0000000?ooool0
Loooool000[ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`03ooooo`03o`000?oo
oooooooo00Sooooo00<00000ooooooooool0Coooool00`3o003ooooo0000000cooooo`80o`0000<0
0000ooooooooool0Loooool000_ooooo1?l00006ooooo`Go00001_ooool00`00003oooooooooo`1@
ooooo`030?l00?ooool00000037ooooo00<0o`00000000000000M_ooool0023ooooo00<00000oooo
ooooool06_ooool4o`0000?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Eoooo
o`Co00000oooool00ol0003oooooo`000005o`0000Cooooo00<0o`00ooooo`0000003oooool4o`00
00?ooooo00?o0000ooooooooool01?l0000Booooo`040?l00000003oooooooooo`Co00000oooool0
0ol0003oooooooooo`03ooooo`03o`000?oooooooooo01Cooooo1?l00003ooooo`03o`000?oooooo
oooo00Co00005oooool4o`0000?ooooo00?o0000ooooooooool01?l0000Oooooo`008?ooool00`00
003oooooooooo`0Iooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01Oooool00ol0
003oooooooooo`0Dooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`08ooooo`030?l00000003ooooo00gooooo00?o0000ooooooooool00_ooool00ol0
003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool03_ooool01@3o
00000000oooooooooooo000000Cooooo00?o0000ooooooooool01_ooool00ol0003oooooooooo`0C
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo01?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02
ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool07?ooool0023ooooo00<00000oooo
ooooool06Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Gooooo00?o0000oooo
ooooool05?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00?ooooo00?o0000oooo
ooooool02?ooool00`3o00000000ooooo`0<ooooo`03o`000?oooooooooo00;ooooo00?o0000oooo
ooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00gooooo00<0o`000000
0?ooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo1_l0000Doooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0Coooo
o`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02oooo
o`03o`000?oooooooooo01cooooo000Pooooo`0300000?oooooooooo01Wooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`05ooooo`03o`000?oooooooooo01Cooooo00?o0000oooooooo
ool00_ooool00ol0003oooooooooo`04ooooo`;o00002Oooool00`3o00000000ooooo`0;ooooo`03
o`000?oooooooooo00;ooooo00?o0000ooooooooool01oooool00ol0003oooooooooo`0<ooooo`03
0?l00000003ooooo00?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`05
o`000?ooooooooooooooool000005Oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00Oooooo00?o0000ooooooooool04oooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Looooo`008?ooool00`00003o
ooooooooo`0Iooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01Oooool00ol0003o
ooooooooo`0Dooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01_ooool00ol0003o
ooooooooo`07ooooo`030?l00000003ooooo00[ooooo00?o0000ooooooooool00_ooool00ol0003o
ooooooooo`04ooooo`?o00003_ooool00`3o00000000ooooo`04ooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool00oooool01?l0003oooooooooool0000Eooooo`03o`000?oooooooooo
00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo
01?ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`;o00000oooool00ol0
003oooooooooo`0Looooo`008?ooool00`00003oooooooooo`0Iooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool01Oooool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo00;o
oooo00?o0000ooooooooool01oooool00ol0003oooooooooo`07ooooo`030?l00000003ooooo00Wo
oooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`07ooooo`03o`000?oooooooooo00Wo
oooo0P3o00000`00003oooooooooo`04ooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool01?ooool00ol0003oooooo`00000Eooooo`03o`000?oooooooooo00;ooooo00?o0000oooooooo
ool00_ooool5o`0001Kooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03
o`000?oooooo000000;o00007oooool0023ooooo00<00000ooooooooool06Oooool00ol0003ooooo
ooooo`02ooooo`03o`000?oooooooooo00?ooooo0ol0000Fooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Sooooo
00<0o`000000000000002?ooool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00;ooooo
00?o0000ooooooooool00_ooool00ol0003oooooooooo`07ooooo`80o`000P000007ooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool01?ooool00ol0003oooooo`00000Eooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Hooooo`03o`00
0?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003oooooooooo`0Qooooo`008?oo
ool00`00003oooooooooo`0Iooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool01Ooo
ool00ol0003oooooooooo`0Dooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`02ooooo`03o`000?oooooooooo00Wooooo0P3o00000`00003ooooooooo
o`05ooooo`03o`000?oooooooooo00;ooooo00?o0000ooooooooool00_ooool00ol0003ooooooooo
o`02ooooo`03o`000?oooooooooo00Gooooo0P3o0002000000Wooooo00?o0000ooooooooool00_oo
ool00ol0003oooooooooo`05ooooo`;o00005Oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00?ooooo00?o0000ooooooooool05oooool00ol0003oooooooooo`02ooooo`03o`000?oo
oooooooo00?ooooo00Go0000ooooooooooooooooo`00000Nooooo`008?ooool00`00003ooooooooo
o`0Jooooo`Co00002?ooool00ol0003oooooooooo`0Eooooo`Co00001_ooool4o`0000kooooo0P3o
00000`00003oooooooooo`04ooooo`Co00001_ooool4o`0000Kooooo0P3o0002000000cooooo1?l0
0009ooooo`03o`000?oooooooooo01Cooooo1?l00006ooooo`Go00005_ooool4o`0000Oooooo0ol0
000Oooooo`008?ooool00`00003oooooooooo`1Looooo`80o`0000<00000ooooooooool05?ooool2
0?l000800000Q?ooool0023ooooo00<00000ooooooooool0G_ooool00`3o00000000ooooo`0Boooo
o`80o`000P000026ooooo`008?ooool00`00003oooooooooo`1Oooooo`80o`0000<00000oooooooo
ool03Oooool20?l000800000R?ooool0023ooooo00<00000ooooooooool0HOooool20?l000Oooooo
1`3o0002000008[ooooo000PooooofH000001`3o002C00000000A?ooool00ol0003oooooooooo`0Q
ooooo`03o`000?oooooooooo02;ooooo00?o0000ooooooooool08Oooool00ol0003oooooooooo`0R
ooooo`03o`000?oooooooooo027ooooo00?o0000ooooooooool08oooool00?oooooo8Oooool00?oo
oooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00?oooooo8Oooool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.0878476, -4.31408, \
0.00274513, 0.0253813}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{4, 1024}, {0, 746}},
WindowSize->{520, 740},
WindowMargins->{{12, Automatic}, {Automatic, 24}},
CellLabelAutoDelete->True
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 84, 1, 27, "Input"],
Cell[1863, 56, 67, 1, 27, "Output"]
}, Open  ]],
Cell[1945, 60, 138, 3, 43, "Input"],
Cell[2086, 65, 147, 3, 75, "Input"],

Cell[CellGroupData[{
Cell[2258, 72, 40, 1, 27, "Input"],
Cell[2301, 75, 77, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2415, 81, 177, 4, 59, "Input"],
Cell[2595, 87, 27835, 798, 186, 12277, 601, "GraphicsData", "PostScript", \
"Graphics"],
Cell[30433, 887, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[30600, 895, 221, 5, 59, "Input"],
Cell[30824, 902, 28918, 852, 186, 13615, 659, "GraphicsData", "PostScript", \
"Graphics"],
Cell[59745, 1756, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[59912, 1764, 88, 1, 27, "Input"],
Cell[60003, 1767, 43952, 1257, 186, 20072, 958, "GraphicsData", "PostScript", \
"Graphics"],
Cell[103958, 3026, 130, 3, 27, "Output"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

